## root-system 5.34.19+dfsg

=== CMakeLists.txt ===
#---Check if cmake has the required version-----------------------------------------------------
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
cmake_policy(SET CMP0005 NEW)
#---Set name of the project to "ROOT". Has to be done after check of cmake version--------------
project(ROOT)
set(IntegratedBuild ON)

#---Set pathes where to put the libraries, executables and headers------------------------------
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(ROOTSYS ${CMAKE_SOURCE_DIR})
set(HEADER_OUTPUT_PATH ${CMAKE_BINARY_DIR}/include)
set(ROOT_INCLUDE_DIR ${HEADER_OUTPUT_PATH})

#---Set the library version in the main CMakeLists.txt------------------------------------------
file(READ ${CMAKE_SOURCE_DIR}/build/version_number versionstr)
string(STRIP ${versionstr} versionstr)
string(REGEX REPLACE "([0-9]+)[.][0-9]+[/][0-9]+" "\\1" ROOT_MAJOR_VERSION ${versionstr})
string(REGEX REPLACE "[0-9]+[.]([0-9]+)[/][0-9]+" "\\1" ROOT_MINOR_VERSION ${versionstr})
string(REGEX REPLACE "[0-9]+[.][0-9]+[/]([0-9]+)" "\\1" ROOT_PATCH_VERSION ${versionstr})
set(ROOT_VERSION "${ROOT_MAJOR_VERSION}.${ROOT_MINOR_VERSION}.${ROOT_PATCH_VERSION}")

#---Where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked-------------
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)

#---Enable Folders in IDE like Visual Studio----------------------------------------------------
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

#---Load some basic macros which are needed later for the confiuration and build----------------
include(RootBuildOptions)
include(RootNewMacros)
include(CheckCompiler)
include(MacroEnsureVersion)

#---Enable CTest package -----------------------------------------------------------------------
#include(CTest)
if(testing)
  enable_testing()
endif()

#---Check if the user wants to build the project in the source directory------------------------
ROOT_CHECK_OUT_OF_SOURCE_BUILD()

#---Here we look for installed software and switch on and of the different build options--------
include(SearchInstalledSoftware)
ROOT_SHOW_OPTIONS()

#---Recurse into the given subdirectories.  This does not actually cause another cmake executable
#  to run. The same process will walk through the project's entire directory structure.
add_subdirectory (cint)
add_subdirectory (core)
add_subdirectory (build)
add_subdirectory (math)
add_subdirectory (hist)
add_subdirectory (tree)
add_subdirectory (io)
add_subdirectory (net)
add_subdirectory (graf2d)
add_subdirectory (graf3d)
add_subdirectory (gui)
add_subdirectory (proof)
add_subdirectory (html)
add_subdirectory (montecarlo)
add_subdirectory (geom)
add_subdirectory (rootx)
add_subdirectory (misc)
add_subdirectory (main)
add_subdirectory (bindings)
add_subdirectory (sql)
if(tmva)
  add_subdirectory(tmva)
endif()
if(roofit)
  add_subdirectory(roofit)
endif()
ROOT_ADD_TEST_SUBDIRECTORY(test)
ROOT_ADD_TEST_SUBDIRECTORY(tutorials)

include(PostInstalledSoftware)

#---Configure and install various files neded later and for clients -----------------------------
include(RootConfiguration)

#---Installation of project-wise artifacts-------------------------------------------------------
if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_INSTALL_PREFIX)
  install(FILES LICENSE DESTINATION ${CMAKE_INSTALL_DOCDIR})
  install(DIRECTORY README/ DESTINATION ${CMAKE_INSTALL_DOCDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY etc/ DESTINATION ${CMAKE_INSTALL_SYSCONFDIR} USE_SOURCE_PERMISSIONS
                         PATTERN ".svn" EXCLUDE 
                         REGEX system.rootrc EXCLUDE 
                         REGEX root.mimes EXCLUDE)
  install(DIRECTORY fonts/  DESTINATION ${CMAKE_INSTALL_FONTDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY icons/  DESTINATION ${CMAKE_INSTALL_ICONDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY macros/ DESTINATION ${CMAKE_INSTALL_MACRODIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY man/    DESTINATION ${CMAKE_INSTALL_MANDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY test/      DESTINATION ${CMAKE_INSTALL_TESTDIR} COMPONENT tests PATTERN ".svn" EXCLUDE)
  install(DIRECTORY tutorials/ DESTINATION ${CMAKE_INSTALL_TUTDIR} COMPONENT tutorials PATTERN ".svn" EXCLUDE)
  install(DIRECTORY cmake/modules DESTINATION ${CMAKE_INSTALL_CMAKEDIR} PATTERN ".svn" EXCLUDE)
  install(FILES build/misc/root.m4 DESTINATION ${CMAKE_INSTALL_ACLOCALDIR})
endif()

#---Configure Testing using CTest----------------------------------------------------------------
if(testing)
  include(RootCTest)
endif()

#---Packaging-------------------------------------------------------------------------------------
include(RootCPack)

=== Makefile ===
# Top level Makefile for ROOT System
# Copyright (c) 2000 Rene Brun and Fons Rademakers
#
# Author: Fons Rademakers, 29/2/2000


##### Check version of GNU make #####

MAKE_VERSION_MAJOR := $(word 1,$(subst ., ,$(MAKE_VERSION)))
MAKE_VERSION_MINOR := $(shell echo $(word 2,$(subst ., ,$(MAKE_VERSION))) | \
                              sed 's/\([0-9][0-9]*\).*/\1/')
MAKE_VERSION_MAJOR ?= 0
MAKE_VERSION_MINOR ?= 0
ORDER_ := $(shell test $(MAKE_VERSION_MAJOR) -gt 3 || \
                  test $(MAKE_VERSION_MAJOR) -eq 3 && \
                  test $(MAKE_VERSION_MINOR) -ge 80 && echo '|')

##### Include path/location macros (result of ./configure) #####

include config/Makefile.config

##### Prevent propagation of user flags to autoconf        #####
##### configure  in bundled autotools projects since we    #####
##### are trying to set all compiler flags ourself and     #####
##### including them could lead to e.g. conflicting 32/64  #####
##### bit build options.
CONFIG_SITE =

##### Include compiler overrides specified via ./configure #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####
##### Included before Makefile.$ARCH only because of f77   #####
##### if case has to be processed                          #####

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include config/Makefile.comp
endif
ifeq ($(MAKECMDGOALS),clean)
include config/Makefile.comp
endif

##### Include machine dependent macros                     #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####

ifndef ROOT_SRCDIR
$(error Please run ./configure first)
endif

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include $(ROOT_SRCDIR)/config/Makefile.$(ARCH)
endif
ifeq ($(MAKECMDGOALS),clean)
include $(ROOT_SRCDIR)/config/Makefile.$(ARCH)
endif

##### Include compiler overrides specified via ./configure #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include config/Makefile.comp
endif
ifeq ($(MAKECMDGOALS),clean)
include config/Makefile.comp
endif

##### Include library dependencies for explicit linking #####

MAKEFILEDEP = $(ROOT_SRCDIR)/config/Makefile.depend
include $(MAKEFILEDEP)

##### Allow local macros #####

-include MyConfig.mk

##### Modules to build #####

MODULES       = build cint/cint core/metautils core/pcre core/clib core/utils \
                core/textinput core/base core/cont core/meta core/thread \
                io/io math/mathcore net/net core/zip core/lzma math/matrix \
                core/newdelete hist/hist tree/tree graf2d/freetype \
                graf2d/mathtext graf2d/graf graf2d/gpad graf3d/g3d \
                gui/gui math/minuit hist/histpainter tree/treeplayer \
                gui/ged tree/treeviewer math/physics graf2d/postscript \
                core/rint html montecarlo/eg \
                geom/geom geom/geompainter montecarlo/vmc \
                math/fumili math/mlp math/quadp net/auth gui/guibuilder io/xml \
                math/foam math/splot math/smatrix io/sql \
                geom/geombuilder hist/spectrum hist/spectrumpainter \
                gui/fitpanel proof/proof proof/proofplayer \
                gui/sessionviewer gui/guihtml gui/recorder

ifeq ($(ARCH),win32)
MODULES      += core/winnt graf2d/win32gdk
MODULES      := $(filter-out core/newdelete,$(MODULES))
SYSTEML       = $(WINNTL)
SYSTEMO       = $(WINNTO)
SYSTEMDO      = $(WINNTDO)
else
ifeq ($(ARCH),win32gcc)
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
else
ifeq ($(ARCH),win64gcc)
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
else
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
endif
endif
endif
ifeq ($(PLATFORM),ios)
MODULES      += graf2d/ios
endif
ifeq ($(BUILDVC),yes)
MODULES      += math/vc
endif
ifeq ($(BUILDVDT),yes)
MODULES      += math/vdt
endif
ifeq ($(BUILDCOCOA),yes)
MODULES      += graf2d/quartz
MODULES      += graf2d/cocoa
MODULES      += core/macosx
MODULES      += rootx
SYSTEML      += $(MACOSXL)
SYSTEMO      += $(MACOSXO)
SYSTEMDO     += $(MACOSXDO)
CORELIBEXTRA += -framework Cocoa
endif
ifeq ($(BUILDX11),yes)
MODULES      += graf2d/x11 graf2d/x11ttf graf3d/x3d rootx
endif
ifeq ($(BUILDGL),yes)
ifeq ($(BUILDFTGL),yes)
MODULES      += graf3d/ftgl
endif
ifeq ($(BUILDGLEW),yes)
MODULES      += graf3d/glew
endif
MODULES      += graf3d/gl graf3d/eve graf3d/gviz3d
endif
ifeq ($(BUILDMYSQL),yes)
MODULES      += sql/mysql
endif
ifeq ($(BUILDORACLE),yes)
MODULES      += sql/oracle
endif
ifeq ($(BUILDPGSQL),yes)
MODULES      += sql/pgsql
endif
ifeq ($(BUILDSQLITE),yes)
MODULES      += sql/sqlite
endif
ifeq ($(BUILDSAPDB),yes)
MODULES      += sql/sapdb
endif
ifeq ($(BUILDODBC),yes)
MODULES      += sql/odbc
endif
ifeq ($(BUILDRFIO),yes)
MODULES      += io/rfio
endif
ifeq ($(BUILDCASTOR),yes)
MODULES      += io/castor
endif
ifeq ($(BUILDDCAP),yes)
MODULES      += io/dcache
endif
ifeq ($(BUILDDAVIX),yes)
MODULES      += net/davix
endif
ifeq ($(BUILDGFAL),yes)
MODULES      += io/gfal
endif
ifeq ($(BUILDGLITE),yes)
MODULES      += net/glite
endif
ifeq ($(BUILDBONJOUR),yes)
MODULES      += net/bonjour
endif
ifeq ($(BUILDCHIRP),yes)
MODULES      += io/chirp
endif
ifeq ($(BUILDHDFS),yes)
MODULES      += io/hdfs
endif
ifeq ($(BUILDMEMSTAT),yes)
MODULES      += misc/memstat
endif
ifeq ($(BUILDASIMAGE),yes)
MODULES      += graf2d/asimage
ifeq ($(BUILDFITSIO),yes)
MODULES      += graf2d/fitsio
endif
endif
ifeq ($(BUILDFPYTHIA6),yes)
MODULES      += montecarlo/pythia6
endif
ifeq ($(BUILDFPYTHIA8),yes)
MODULES      += montecarlo/pythia8
endif
ifeq ($(BUILDFFTW3),yes)
MODULES      += math/fftw
endif
ifeq ($(BUILDGVIZ),yes)
MODULES      += graf2d/gviz
endif
ifeq ($(BUILDPYTHON),yes)
MODULES      += bindings/pyroot
endif
ifeq ($(BUILDRUBY),yes)
MODULES      += bindings/ruby
endif
ifeq ($(BUILDXML),yes)
MODULES      += io/xmlparser
endif
ifeq ($(BUILDQT),yes)
MODULES      += graf2d/qt gui/qtroot
endif
ifeq ($(BUILDQTGSI),yes)
MODULES      += gui/qtgsi
endif
ifeq ($(BUILDGENVECTOR),yes)
MODULES      += math/genvector
endif
ifeq ($(BUILDMATHMORE),yes)
MODULES      += math/mathmore
endif
ifeq ($(BUILDREFLEX),yes)
# put reflex right in front of CINT; CINT needs it
MODULES      := $(subst cint/cint,cint/reflex cint/cint,$(MODULES))
endif
ifeq ($(BUILDMINUIT2),yes)
MODULES      += math/minuit2
endif
ifeq ($(BUILDUNURAN),yes)
MODULES      += math/unuran
endif
ifeq ($(BUILDCLING),yes)
# put cling right behind of CINT; e.g. UTILS need it
MODULES      := $(subst cint/cint,cint/cint cint/cling,$(MODULES))
endif
ifeq ($(BUILDCINTEX),yes)
MODULES      += cint/cintex
endif
ifeq ($(BUILDROOFIT),yes)
MODULES      += roofit/roofitcore roofit/roofit roofit/roostats
ifeq ($(BUILDXML),yes)
MODULES      += roofit/histfactory
endif
endif
ifeq ($(BUILDGDML),yes)
MODULES      += geom/gdml
endif
ifeq ($(BUILDTABLE),yes)
MODULES      += misc/table
endif
ifeq ($(BUILDSRPUTIL),yes)
MODULES      += net/srputils
endif
ifeq ($(BUILDKRB5),yes)
MODULES      += net/krb5auth
endif
ifeq ($(BUILDLDAP),yes)
MODULES      += net/ldap
endif
ifeq ($(BUILDMONALISA),yes)
MODULES      += net/monalisa
endif
ifeq ($(BUILDGLOBUS),yes)
MODULES      += net/globusauth
endif
ifneq ($(F77),)
MODULES      += misc/minicern hist/hbook
endif
ifeq ($(HASXRD),yes)
MODULES      += net/netx
ifeq ($(BUILDNETXNG),yes)
MODULES      += net/netxng
endif
ifeq ($(BUILDALIEN),yes)
MODULES      += net/alien
endif
endif
ifneq ($(ARCH),win32)
MODULES      += net/rpdutils net/rootd proof/proofd proof/pq2 proof/proofbench
endif
ifeq ($(BUILDTMVA),yes)
MODULES      += tmva math/genetic
endif
ifeq ($(HASXRD),yes)
ifeq ($(ARCH),win32)
MODULES      += proof/proofd
endif
MODULES      += proof/proofx
endif
ifeq ($(BUILDAFDSMGRD),yes)
MODULES      += proof/afdsmgrd
endif
ifeq ($(BUILDHTTP),yes)
MODULES      += net/http
endif

-include MyModules.mk   # allow local modules

ifneq ($(findstring $(MAKECMDGOALS),distclean maintainer-clean),)
MODULES      += core/unix core/winnt graf2d/x11 graf2d/x11ttf \
                graf3d/gl graf3d/ftgl graf3d/glew io/rfio io/castor \
                montecarlo/pythia6 montecarlo/pythia8 misc/table \
                sql/mysql sql/pgsql sql/sqlite sql/sapdb net/srputils \
                rootx net/rootd io/dcache io/chirp hist/hbook graf2d/asimage \
                net/ldap net/krb5auth net/rpdutils net/globusauth \
                bindings/pyroot bindings/ruby io/gfal misc/minicern \
                graf2d/qt gui/qtroot gui/qtgsi net/netx net/netxng net/alien \
                proof/proofd proof/proofx proof/pq2 graf3d/x3d net/davix \
                sql/oracle io/xmlparser math/mathmore cint/reflex cint/cintex \
                tmva math/genetic io/hdfs graf2d/fitsio roofit/roofitcore \
                roofit/roofit roofit/roostats roofit/histfactory \
                math/minuit2 net/monalisa math/fftw sql/odbc math/unuran \
                geom/gdml graf3d/eve net/glite misc/memstat \
                math/genvector net/bonjour graf3d/gviz3d graf2d/gviz \
                proof/proofbench proof/afdsmgrd cint/cling graf2d/ios \
                graf2d/quartz graf2d/cocoa core/macosx net/http
MODULES      := $(sort $(MODULES))   # removes duplicates
endif

MODULES      += main   # must be last, $(ALLLIBS) must be fully formed

ifeq ($(BUILDTOOLS),yes)
MODULES       = build cint/cint core/metautils core/clib core/base core/meta \
                core/utils
endif

##### ROOT libraries #####

LPATH         = lib

ifneq ($(PLATFORM),win32)
RPATH        := -L$(LPATH)
CINTLIBS     := -lCint
NEWLIBS      := -lNew
BOOTLIBS     := -lCore -lCint
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBS     += -lCintex -lReflex
endif
ifeq ($(BUILDCLING),yes)
BOOTLIBS     += -lCling
endif
ROOTLIBS     := -lRIO -lHist -lGraf -lGraf3d -lGpad -lTree \
                -lMatrix -lNet -lThread -lMathCore $(BOOTLIBS)
RINTLIBS     := -lRint
else
CINTLIBS     := $(LPATH)/libCint.lib
NEWLIBS      := $(LPATH)/libNew.lib
BOOTLIBS     := $(LPATH)/libCore.lib $(LPATH)/libCint.lib
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBS     += $(LPATH)/libCintex.lib $(LPATH)/libReflex.lib
endif
ifeq ($(BUILDCLING),yes)
BOOTLIBS     += $(LPATH)/libCling.lib
endif
ROOTLIBS     := $(LPATH)/libRIO.lib $(LPATH)/libHist.lib \
                $(LPATH)/libGraf.lib $(LPATH)/libGraf3d.lib \
                $(LPATH)/libGpad.lib $(LPATH)/libTree.lib \
                $(LPATH)/libMatrix.lib $(LPATH)/libNet.lib \
                $(LPATH)/libThread.lib $(LPATH)/libMathCore.lib \
                $(BOOTLIBS)
RINTLIBS     := $(LPATH)/libRint.lib
endif

ROOTALIB     := $(LPATH)/libRoot.a
ROOTA        := bin/roota
PROOFSERVA   := bin/proofserva

# ROOTLIBSDEP is intended to match the content of ROOTLIBS
BOOTLIBSDEP   = $(ORDER_) $(CORELIB) $(CINTLIB)
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBSDEP  += $(CINTEXLIB) $(REFLEXLIB)
endif
ROOTLIBSDEP   = $(BOOTLIBSDEP) $(MATHCORELIB) $(IOLIB) $(NETLIB) $(HISTLIB) \
                $(GRAFLIB) $(G3DLIB) $(GPADLIB) $(TREELIB) $(MATRIXLIB)

# Force linking of not referenced libraries
ifeq ($(FORCELINK),yes)
ifeq ($(PLATFORM),aix5)
ROOTULIBS    := -Wl,-u,.G__cpp_setupG__Net      \
                -Wl,-u,.G__cpp_setupG__IO       \
                -Wl,-u,.G__cpp_setupG__Hist     \
                -Wl,-u,.G__cpp_setupG__Graf     \
                -Wl,-u,.G__cpp_setupG__G3D      \
                -Wl,-u,.G__cpp_setupG__GPad     \
                -Wl,-u,.G__cpp_setupG__Tree     \
                -Wl,-u,.G__cpp_setupG__Thread   \
                -Wl,-u,.G__cpp_setupG__Matrix
else
ifeq ($(PLATFORM),macosx)
LDSYMPREFIX  := _
endif

=== proof/CMakeLists.txt ===
add_subdirectory(proof)
add_subdirectory(proofplayer) # special CMakeListst.txt
if(afdsmgrd)
  add_subdirectory(afdsmgrd)
endif()
if(xrootd AND ssl)
  add_subdirectory(proofd)
  add_subdirectory(proofx)
  add_subdirectory(proofbench)
endif()

=== rootx/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT rootx package
# @author Pere Mato, CERN
############################################################################

ROOT_USE_PACKAGE(core)
if(x11)
  include_directories(${X11_INCLUDE_DIR})
  ROOT_EXECUTABLE(root *.cxx  ${CMAKE_SOURCE_DIR}/core/clib/src/strlcpy.c
                  LIBRARIES ${X11_LIBRARIES} ${X11_Xpm_LIB} ${X11_Xft_LIB} ${X11_Xext_LIB})
elseif(cocoa)
  add_custom_target(root ALL 
                    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/root.exe ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/root)
  add_dependencies(root root.exe)
  set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/root)
  install(PROGRAMS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/root
          DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications)

endif()

=== test/CMakeLists.txt ===
# CMakeLists.txt for the ROOT test programs.
# This shows nicely how to compile and link applications
# using the ROOT libraries on all supported platforms.
#
# Author: Pere Mato, 25/10/2010
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(test)
find_package(ROOT REQUIRED)

include(${ROOT_USE_FILE})

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

if(CMAKE_SYSTEM_NAME MATCHES Darwin)
  # To avoid to set ld_Library_path to locate the test libraries
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-rpath,@loader_path/.")
endif()

include_directories(${ROOT_INCLUDE_DIRS})
if(DEFINED ROOT_SOURCE_DIR)  # Testing using the binary tree
  include_directories(${ROOT_SOURCE_DIR}/tutorials)
  include_directories(${ROOT_SOURCE_DIR}/tmva/inc)
else()
  include_directories(${ROOT_INCLUDE_DIRS}/../tutorials)
endif()

#---environment-------------------------------------------------------------------------------
ROOT_ADD_TEST(show-environment COMMAND ${CMAKE_COMMAND} -E environment)

#---hworld------------------------------------------------------------------------------------
ROOT_EXECUTABLE(hworld hworld.cxx LIBRARIES Gpad)

#---event-------------------------------------------------------------------------------------
ROOT_GENERATE_DICTIONARY(EventDict ${CMAKE_CURRENT_SOURCE_DIR}/Event.h LINKDEF EventLinkDef.h)
ROOT_LINKER_LIBRARY(Event Event.cxx EventDict.cxx LIBRARIES Hist MathCore)

ROOT_EXECUTABLE(testevent MainEvent.cxx LIBRARIES Event RIO Tree Hist Net)
ROOT_ADD_TEST(test-event COMMAND testevent)

#---hsimple------------------------------------------------------------------------------------
ROOT_EXECUTABLE(hsimple hsimple.cxx LIBRARIES RIO Tree Hist)
ROOT_ADD_TEST(test-hsimple COMMAND hsimple)

#--minexam-------------------------------------------------------------------------------------
ROOT_EXECUTABLE(minexam minexam.cxx LIBRARIES Minuit)
ROOT_ADD_TEST(test-minexam COMMAND minexam)

#--tstring-------------------------------------------------------------------------------------
ROOT_EXECUTABLE(tstring tstring.cxx LIBRARIES Core)
configure_file(tstring.cxx tstring.cxx @COPY_ONLY)
ROOT_ADD_TEST(test-tstring COMMAND tstring)

#--tcollex-------------------------------------------------------------------------------------
ROOT_EXECUTABLE(tcollex tcollex.cxx LIBRARIES Core)
ROOT_ADD_TEST(test-tcollex COMMAND tcollex)

#--tcollbm------------------------------------------------------------------------------------
ROOT_EXECUTABLE(tcollbm tcollbm.cxx LIBRARIES Core MathCore)
ROOT_ADD_TEST(test-tcollbm COMMAND tcollbm 1000 100000)

#--vvector------------------------------------------------------------------------------------
ROOT_EXECUTABLE(vvector vvector.cxx LIBRARIES Core Matrix RIO)
ROOT_ADD_TEST(test-vvector COMMAND vvector)

#--vmatrix------------------------------------------------------------------------------------
ROOT_EXECUTABLE(vmatrix vmatrix.cxx LIBRARIES Core Matrix RIO)
ROOT_ADD_TEST(test-vmatrix COMMAND vmatrix)

#--vlazy------------------------------------------------------------------------------------
ROOT_EXECUTABLE(vlazy vlazy.cxx LIBRARIES Core Matrix)
ROOT_ADD_TEST(test-vlazy COMMAND vlazy)

#--helloso------------------------------------------------------------------------------------
ROOT_GENERATE_DICTIONARY(HelloDict ${CMAKE_CURRENT_SOURCE_DIR}/Hello.h)
ROOT_LINKER_LIBRARY(Hello Hello.cxx HelloDict.cxx LIBRARIES Graf Gpad)

#--Aclockso------------------------------------------------------------------------------------
ROOT_GENERATE_DICTIONARY(AclockDict ${CMAKE_CURRENT_SOURCE_DIR}/Aclock.h)
ROOT_LINKER_LIBRARY(Aclock Aclock.cxx AclockDict.cxx LIBRARIES Graf Gpad)

#--bench------------------------------------------------------------------------------------
ROOT_GENERATE_DICTIONARY(TBenchDict ${CMAKE_CURRENT_SOURCE_DIR}/TBench.h LINKDEF benchLinkDef.h)
ROOT_LINKER_LIBRARY(TBench TBench.cxx TBenchDict.cxx LIBRARIES Core MathCore RIO Tree)
ROOT_EXECUTABLE(bench bench.cxx LIBRARIES Core TBench)
ROOT_ADD_TEST(test-bench COMMAND bench)

#--stress------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stress stress.cxx LIBRARIES Event Core Hist RIO Tree Gpad Postscript)
ROOT_ADD_TEST(test-stress COMMAND stress -b FAILREGEX "FAILED")

#--stressShapes------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressShapes stressShapes.cxx LIBRARIES  Geom Tree GenVector Gpad)
ROOT_ADD_TEST(test-stressshapes COMMAND stressShapes -b FAILREGEX "FAILED")

#--stressGeometry------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressGeometry stressGeometry.cxx LIBRARIES Geom Tree GenVector Gpad)
ROOT_ADD_TEST(test-stressgeometry COMMAND stressGeometry -b FAILREGEX "FAILED")

#--stressLinear------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressLinear stressLinear.cxx LIBRARIES Matrix Hist RIO)
ROOT_ADD_TEST(test-stresslinear COMMAND stressLinear FAILREGEX "FAILED")

#--stressGraphics------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressGraphics stressGraphics.cxx LIBRARIES Graf Gpad Postscript)
configure_file(stressGraphics.ref stressGraphics.ref @COPY_ONLY) 
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/../tutorials/graphics/earth.dat earth.dat @COPY_ONLY)
ROOT_ADD_TEST(test-stressgraphics COMMAND stressGraphics -b FAILREGEX "FAILED")

#--stressHistogram------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressHistogram stressHistogram.cxx LIBRARIES Hist RIO)
ROOT_ADD_TEST(test-stresshistogram COMMAND stressHistogram FAILREGEX "FAILED")

#--stressGUI---------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressGUI stressGUI.cxx LIBRARIES Gui Recorder GuiHtml ASImageGui)
#---Cannot run GUI test in batch mode--------------------
#configure_file(stressGUI.ref stressGUI.ref @COPY_ONLY)
#ROOT_ADD_TEST(test-stressgui COMMAND stressGUI -ref FAILREGEX "FAILED")

#--stressSpectrum----------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressSpectrum stressSpectrum.cxx LIBRARIES Hist Spectrum Gpad)
ROOT_ADD_TEST(test-stressspectrum COMMAND stressSpectrum -b FAILREGEX "FAILED")

#--stressVector------------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressVector stressVector.cxx LIBRARIES Physics GenVector)
ROOT_ADD_TEST(test-stressvector COMMAND stressVector FAILREGEX "FAILED")

#--stressTMVA--------------------------------------------------------------------------------------
if(ROOT_tmva_FOUND)
  ROOT_EXECUTABLE(stressTMVA stressTMVA.cxx LIBRARIES TMVA)
  ROOT_ADD_TEST(test-stresstmva COMMAND stressTMVA -b)  
endif()

#--stressMathMore----------------------------------------------------------------------------------
if(ROOT_mathmore_FOUND)
  ROOT_EXECUTABLE(stressMathMore stressMathMore.cxx LIBRARIES MathMore)
  ROOT_ADD_TEST(test-stressmathmore COMMAND stressMathMore FAILREGEX "FAILED")  
endif()

#--stressMathCore----------------------------------------------------------------------------------
if(ROOT_mathcore_FOUND)
  ROOT_EXECUTABLE(stressMathCore stressMathCore.cxx LIBRARIES MathCore)
  ROOT_ADD_TEST(test-stressmathcore COMMAND stressMathCore FAILREGEX "FAILED")  
endif()

#--stressRooFit----------------------------------------------------------------------------------
if(ROOT_roofit_FOUND)
  ROOT_EXECUTABLE(stressRooFit stressRooFit.cxx LIBRARIES RooFit)
  ROOT_ADD_TEST(test-stressroofit COMMAND stressRooFit FAILREGEX "FAILED")  
endif()

#--stressRooStats----------------------------------------------------------------------------------
if(ROOT_roofit_FOUND)
  ROOT_EXECUTABLE(stressRooStats stressRooStats.cxx LIBRARIES RooStats)
  ROOT_ADD_TEST(test-stressroostats COMMAND stressRooStats -f ${CMAKE_SOURCE_DIR}/test/stressRooStats_ref.root FAILREGEX "FAILED")  
endif()

#--stressHistFactory--------------------------------------------------------------------------------
if(ROOT_roofit_FOUND)
if(ROOT_xml_FOUND)
  ROOT_EXECUTABLE(stressHistFactory stressHistFactory.cxx LIBRARIES RooStats HistFactory XMLParser)
  file(COPY ${CMAKE_SOURCE_DIR}/test/HistFactoryTest.tar DESTINATION  ${CMAKE_CURRENT_BINARY_DIR} )
  ROOT_ADD_TEST(test-stressHistFactory ENVIRONMENT ROOTSYS=${CMAKE_BINARY_DIR} COMMAND stressHistFactory -f ${CMAKE_SOURCE_DIR}/test/stressHistFactory_ref.root FAILREGEX "FAILED")  
endif()
endif()

#--stressFit---------------------------------------------------------------------------------
ROOT_EXECUTABLE(stressFit stressFit.cxx LIBRARIES MathCore Matrix)
ROOT_ADD_TEST(test-stressfit COMMAND stressFit FAILREGEX "FAILED")

#--stressHistoFit-----------------------------------------------------------------------------
if(ROOT_unuran_FOUND)
  ROOT_EXECUTABLE(stressHistoFit stressHistoFit.cxx LIBRARIES MathCore Matrix Unuran Tree Gpad)
  ROOT_ADD_TEST(test-stresshistofit COMMAND stressHistoFit FAILREGEX "FAILED")
endif()

#--stressEntryList---------------------------------------------------------------------------
ROOT_EXECUTABLE(stressEntryList stressEntryList.cxx LIBRARIES MathCore Tree Hist)
ROOT_ADD_TEST(test-stressentrylist COMMAND stressEntryList -b FAILREGEX "FAILED")

#--stressIterators---------------------------------------------------------------------------
ROOT_EXECUTABLE(stressIterators stressIterators.cxx LIBRARIES Core)
ROOT_ADD_TEST(test-stressiterators COMMAND stressIterators FAILREGEX "FAILED")

#--stressInterpreter-------------------------------------------------------------------------
ROOT_EXECUTABLE(stressInterpreter stressInterpreter.cxx LIBRARIES Core)
if(WIN32)
  set(cleantmpfiles POSTCMD cmd /c del AutoDict_*)
  set(cfgdir /${CMAKE_BUILD_TYPE})
endif()
ROOT_ADD_TEST(test-stressinterpreter COMMAND stressInterpreter
              PRECMD ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/stressInterpreter.cxx 
                                              $<TARGET_FILE_DIR:stressInterpreter>/stressInterpreter.cxx
              ${cleantmpfiles}
              ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin${cfgdir}#$ENV{PATH}
              FAILREGEX "FAILED|Error")

#--stressHepix-------------------------------------------------------------------------------
#ROOT_EXECUTABLE(stressHepix stressHepix.cxx LIBRARIES Core)
#ROOT_ADD_TEST(test-stressHepix COMMAND stressHepix FAILREGEX "FAILED")

#--stressProof-------------------------------------------------------------------------------
if(NOT WIN32 AND ROOT_xrootd_FOUND)
  add_custom_target(TestData ALL COMMAND ${CMAKE_COMMAND} -DDST=${CMAKE_SOURCE_DIR}/files -P ${CMAKE_CURRENT_SOURCE_DIR}/rootDownloadData.cmake)  
  ROOT_EXECUTABLE(stressProof stressProof.cxx LIBRARIES Proof ProofPlayer Hist)
  ROOT_ADD_TEST(test-stressproof COMMAND stressProof lite:// 
                                         -h1 ${CMAKE_SOURCE_DIR}/files/h1 -event ${CMAKE_SOURCE_DIR}/files/event
                                         -l /tmp/stressProof-%d.log -cleanlog -catlog -noprogress
                                         ENVIRONMENT PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
                                         FAILREGEX "FAILED")  
endif()

#--testbits----------------------------------------------------------------------------------
ROOT_EXECUTABLE(testbits testbits.cxx LIBRARIES Core)
ROOT_ADD_TEST(test-testbits COMMAND testbits)  

#--ctorture----------------------------------------------------------------------------------
ROOT_EXECUTABLE(ctorture ctorture.cxx LIBRARIES MathCore)
ROOT_ADD_TEST(test-ctorture COMMAND ctorture)  

#--qprandom----------------------------------------------------------------------------------

=== test/Makefile ===
# Makefile for the ROOT test programs.
# This Makefile shows nicely how to compile and link applications
# using the ROOT libraries on all supported platforms.
#
# Copyright (c) 2000 Rene Brun and Fons Rademakers
#
# Author: Fons Rademakers, 29/2/2000

RC     := root-config
ifeq ($(shell which $(RC) 2>&1 | sed -ne "s@.*/$(RC)@$(RC)@p"),$(RC))
MKARCH := $(wildcard $(shell $(RC) --etcdir)/Makefile.arch)
RCONFIG := $(wildcard $(shell $(RC) --incdir)/RConfigure.h)
endif
ifneq ($(MKARCH),)
include $(MKARCH)
else
ifeq ($(ROOTSYS),)
ROOTSYS = ..
endif
include $(ROOTSYS)/etc/Makefile.arch
endif
# Tutorials dir needed by stressProof
ifneq ($(RCONFIG),)
TUTDIR := $(wildcard $(shell grep ROOTDOCDIR $(RCONFIG) | sed "s|.*\"\(.*\)\"|\1|")/tutorials)
endif
ifeq ($(TUTDIR),)
ifeq ($(ROOTSYS),)
ROOTSYS = ..
endif
TUTDIR := $(ROOTSYS)/tutorials
endif
-include ../MyConfig.mk

#------------------------------------------------------------------------------

EVENTO        = Event.$(ObjSuf) EventDict.$(ObjSuf)
EVENTS        = Event.$(SrcSuf) EventDict.$(SrcSuf)
EVENTSO       = libEvent.$(DllSuf)
EVENT         = Event$(ExeSuf)
ifeq ($(PLATFORM),win32)
EVENTLIB      = libEvent.lib
else
EVENTLIB      = $(shell pwd)/$(EVENTSO)
endif

EVENTMTO      = EventMT.$(ObjSuf) EventMTDict.$(ObjSuf)
EVENTMTS      = EventMT.$(SrcSuf) EventMTDict.$(SrcSuf)
EVENTMTSO     = libEventMT.$(DllSuf)
ifeq ($(PLATFORM),win32)
EVENTMTLIB    = libEventMT.lib
else
EVENTMTLIB    = $(shell pwd)/$(EVENTMTSO)
endif

MAINEVENTO    = MainEvent.$(ObjSuf)
MAINEVENTS    = MainEvent.$(SrcSuf)

HWORLDO       = hworld.$(ObjSuf)
HWORLDS       = hworld.$(SrcSuf)
HWORLD        = hworld$(ExeSuf)

CTORTUREO     = ctorture.$(ObjSuf)
CTORTURES     = ctorture.$(SrcSuf)
CTORTURE      = ctorture$(ExeSuf)

HSIMPLEO      = hsimple.$(ObjSuf)
HSIMPLES      = hsimple.$(SrcSuf)
HSIMPLE       = hsimple$(ExeSuf)

MINEXAMO      = minexam.$(ObjSuf)
MINEXAMS      = minexam.$(SrcSuf)
MINEXAM       = minexam$(ExeSuf)

TSTRINGO      = tstring.$(ObjSuf)
TSTRINGS      = tstring.$(SrcSuf)
TSTRING       = tstring$(ExeSuf)

TCOLLEXO      = tcollex.$(ObjSuf)
TCOLLEXS      = tcollex.$(SrcSuf)
TCOLLEX       = tcollex$(ExeSuf)

TCOLLBMO      = tcollbm.$(ObjSuf)
TCOLLBMS      = tcollbm.$(SrcSuf)
TCOLLBM       = tcollbm$(ExeSuf)

VVECTORO      = vvector.$(ObjSuf)
VVECTORS      = vvector.$(SrcSuf)
VVECTOR       = vvector$(ExeSuf)

VMATRIXO      = vmatrix.$(ObjSuf)
VMATRIXS      = vmatrix.$(SrcSuf)
VMATRIX       = vmatrix$(ExeSuf)

STRESSLO      = stressLinear.$(ObjSuf)
STRESSLS      = stressLinear.$(SrcSuf)
STRESSL       = stressLinear$(ExeSuf)

STRESSGO      = stressGraphics.$(ObjSuf)
STRESSGS      = stressGraphics.$(SrcSuf)
STRESSG       = stressGraphics$(ExeSuf)

STRESSGUIO    = stressGUI.$(ObjSuf)
STRESSGUIS    = stressGUI.$(SrcSuf)
STRESSGUI     = stressGUI$(ExeSuf)
ifeq ($(PLATFORM),win32)
STRESSGUILIBS = '$(ROOTSYS)/lib/libASImage.lib' '$(ROOTSYS)/lib/libASImageGui.lib' \
                '$(ROOTSYS)/lib/libRecorder.lib' '$(ROOTSYS)/lib/libGuiHtml.lib' 
else
STRESSGUILIBS = -lASImage -lASImageGui -lRecorder -lGuiHtml
endif

ifeq ($(shell $(RC) --has-genvector),yes)
STRESSVECO   = stressVector.$(ObjSuf)
STRESSVECS   = stressVector.$(SrcSuf)
STRESSVEC    = stressVector$(ExeSuf)

STRESSMATHO   = stressMathCore.$(ObjSuf) 
STRESSMATHS   = stressMathCore.$(SrcSuf) 
ifneq ($(USE_REFLEX),)
CXXFLAGS += -DUSE_REFLEX
ifeq ($(PLATFORM),win32)
STRESSMATHLIBS = '$(ROOTSYS)/lib/libGenVector.lib' '$(ROOTSYS)/lib/libReflex.lib' '$(ROOTSYS)/lib/libCintex.lib' 
else
STRESSMATHLIBS = -lGenVector -lReflex -lCintex
endif

TRACKMATHSRC = TrackMathCoreRflx.$(SrcSuf)
TRACKMATHOBJ = TrackMathCoreRflx.$(ObjSuf)
TRACKMATHLIB = libTrackMathCoreRflx.$(DllSuf)

else 

ifeq ($(PLATFORM),win32)
STRESSMATHLIBS = '$(ROOTSYS)/lib/libGenVector.lib'
else
STRESSMATHLIBS = -lGenVector
endif

TRACKMATHSRC = TrackMathCoreDict.$(SrcSuf)
TRACKMATHOBJ = TrackMathCoreDict.$(ObjSuf)
TRACKMATHLIB = libTrackMathCoreDict.$(DllSuf)
 
endif

STRESSMATH    = stressMathCore$(ExeSuf)

endif

ifeq ($(shell $(RC) --has-mathmore),yes)
STRESSMATHMOREO   = stressMathMore.$(ObjSuf) 
STRESSMATHMORES   = stressMathMore.$(SrcSuf)  
ifeq ($(PLATFORM),win32)
STRESSMATHMORELIBS = '$(ROOTSYS)/lib/libMathMore.lib'  
else
STRESSMATHMORELIBS = -lMathMore
endif
STRESSMATHMORE    = stressMathMore$(ExeSuf)
endif

ifeq ($(shell $(RC) --has-tmva),yes)
STRESSTMVAO   = stressTMVA.$(ObjSuf)
STRESSTMVAS   = stressTMVA.$(SrcSuf)
ifeq ($(PLATFORM),win32)
STRESSTMVALIBS = '$(ROOTSYS)/lib/libTMVA.lib'
else
STRESSTMVALIBS = -lTMVA -lMinuit -lXMLIO -lMLP -lTreePlayer
endif
STRESSTMVA    = stressTMVA$(ExeSuf)
endif

VLAZYO        = vlazy.$(ObjSuf)
VLAZYS        = vlazy.$(SrcSuf)
VLAZY         = vlazy$(ExeSuf)

GUITESTO      = guitest.$(ObjSuf)
GUITESTS      = guitest.$(SrcSuf)
GUITEST       = guitest$(ExeSuf)

GUIVIEWERO    = guiviewer.$(ObjSuf) guiviewerDict.$(ObjSuf)
GUIVIEWERS    = guiviewer.$(SrcSuf) guiviewerDict.$(SrcSuf)
GUIVIEWER     = guiviewer$(ExeSuf)

HELLOO        = Hello.$(ObjSuf) HelloDict.$(ObjSuf)
HELLOS        = Hello.$(SrcSuf) HelloDict.$(SrcSuf)
HELLOSO       = Hello.$(DllSuf)

ACLOCKO       = Aclock.$(ObjSuf) AclockDict.$(ObjSuf)
ACLOCKS       = Aclock.$(SrcSuf) AclockDict.$(SrcSuf)
ACLOCKSO      = Aclock.$(DllSuf)

TETRISO       = Tetris.$(ObjSuf) TetrisDict.$(ObjSuf)
TETRISS       = Tetris.$(SrcSuf) TetrisDict.$(SrcSuf)
TETRISSO      = Tetris.$(DllSuf)

STRESSO       = stress.$(ObjSuf)
STRESSS       = stress.$(SrcSuf)
STRESS        = stress$(ExeSuf)

STRESSGEOMETRYO   = stressGeometry.$(ObjSuf)
STRESSGEOMETRYS   = stressGeometry.$(SrcSuf)
STRESSGEOMETRY    = stressGeometry$(ExeSuf)

STRESSSHAPESO   = stressShapes.$(ObjSuf)
STRESSSHAPESS   = stressShapes.$(SrcSuf)
STRESSSHAPES    = stressShapes$(ExeSuf)

ifeq ($(shell $(RC) --has-roofit),yes)
STRESSROOFITO  = stressRooFit.$(ObjSuf)
STRESSROOFITS  = stressRooFit.$(SrcSuf)
STRESSROOFIT   = stressRooFit$(ExeSuf)

STRESSROOSTATSO  = stressRooStats.$(ObjSuf)
STRESSROOSTATSS  = stressRooStats.$(SrcSuf)
STRESSROOSTATS   = stressRooStats$(ExeSuf)

ifeq ($(shell $(RC) --has-xml),yes)
STRESSHISTFACTORYO  = stressHistFactory.$(ObjSuf)
STRESSHISTFACTORYS  = stressHistFactory.$(SrcSuf)
STRESSHISTFACTORY   = stressHistFactory$(ExeSuf)
endif

endif

STRESSFITO    = stressFit.$(ObjSuf)
STRESSFITS    = stressFit.$(SrcSuf)
STRESSFIT     = stressFit$(ExeSuf)

ifeq ($(shell $(RC) --has-unuran),yes)
ifeq ($(shell $(RC) --has-minuit2),yes)
STRESSHISTOFITO    = stressHistoFit.$(ObjSuf)
STRESSHISTOFITS    = stressHistoFit.$(SrcSuf)
STRESSHISTOFIT     = stressHistoFit$(ExeSuf)
endif
endif

STRESSENTRYLISTO = stressEntryList.$(ObjSuf)
STRESSENTRYLISTS = stressEntryList.$(SrcSuf)
STRESSENTRYLIST  = stressEntryList$(ExeSuf)

STRESSHEPIXO  = stressHepix.$(ObjSuf)
STRESSHEPIXS  = stressHepix.$(SrcSuf)
STRESSHEPIX   = stressHepix$(ExeSuf)

STRESSSPO     = stressSpectrum.$(ObjSuf)
STRESSSPS     = stressSpectrum.$(SrcSuf)
STRESSSP      = stressSpectrum$(ExeSuf)

STRESSPROOFO  = stressProof.$(ObjSuf)
STRESSPROOFS  = stressProof.$(SrcSuf)
STRESSPROOF   = stressProof$(ExeSuf)

TBENCHO       = TBench.$(ObjSuf) TBenchDict.$(ObjSuf)
TBENCHS       = TBench.$(SrcSuf) TBenchDict.$(SrcSuf)
TBENCHSO      = TBench.$(DllSuf)

BENCHO        = bench.$(ObjSuf)
BENCHS        = bench.$(SrcSuf)
BENCH         = bench$(ExeSuf)

TESTBITSO     = testbits.$(ObjSuf)
TESTBITSS     = testbits.$(SrcSuf)
TESTBITS      = testbits$(ExeSuf)

QPRANDOMO     = QpRandomDriver.$(ObjSuf)
QPRANDOMS     = QpRandomDriver.$(SrcSuf)
QPRANDOM      = QpRandomDriver$(ExeSuf)

THREADSO      = threads.$(ObjSuf)
THREADSS      = threads.$(SrcSuf)
THREADS       = threads$(ExeSuf)

STRESSINTERPO = stressInterpreter.$(ObjSuf)
STRESSINTERPS = stressInterpreter.$(SrcSuf)
STRESSINTERP  = stressInterpreter$(ExeSuf)

STRESSITERO    = stressIterators.$(ObjSuf)
STRESSITERS    = stressIterators.$(SrcSuf)
STRESSITER     = stressIterators$(ExeSuf)

STRESSHISTO   = stressHistogram.$(ObjSuf)
STRESSHISTS   = stressHistogram.$(SrcSuf)
STRESSHIST    = stressHistogram$(ExeSuf)

ifeq ($(shell $(RC) --has-sqlite),yes)
SQLITETESTO   = sqlitetest.$(ObjSuf)
SQLITETESTS   = sqlitetest.$(SrcSuf)
SQLITETEST    = sqlitetest$(ExeSuf)
endif


OBJS          = $(EVENTO) $(MAINEVENTO) $(EVENTMTO) $(HWORLDO) $(HSIMPLEO) \
                $(MINEXAMO) \
                $(TSTRINGO) $(TCOLLEXO) $(VVECTORO) $(VMATRIXO) $(VLAZYO) \
                $(HELLOO) $(ACLOCKO) $(STRESSO) $(TBENCHO) $(BENCHO) \
                $(STRESSSHAPESO) $(TCOLLBMO) $(STRESSGEOMETRYO) $(STRESSLO) \
                $(STRESSGO) $(STRESSSPO) $(TESTBITSO) \
                $(CTORTUREO) $(QPRANDOMO) $(THREADSO) $(STRESSVECO) \
                $(STRESSMATHO) $(STRESSFITO) $(STRESSHISTOFITO) \
                $(STRESSHEPIXO) $(STRESSENTRYLISTO) $(STRESSROOFITO) \
                $(STRESSROOSTATSO) $(STRESSHISTFACTORYO) \
                $(STRESSPROOFO) $(STRESSMATHMOREO) \
                $(STRESSTMVAO) $(STRESSINTERPO) $(STRESSITERO) \
                $(STRESSHISTO) $(STRESSGUIO) $(SQLITETESTO)

PROGRAMS      = $(EVENT) $(EVENTMTSO) $(HWORLD) $(HSIMPLE) $(MINEXAM) \
                $(TSTRING) $(TCOLLEX) $(TCOLLBM) $(VVECTOR) $(VMATRIX) \
                $(VLAZY) $(HELLOSO) $(ACLOCKSO) $(STRESS) $(TBENCHSO) $(BENCH) \
                $(STRESSSHAPES) $(STRESSGEOMETRY) $(STRESSL) $(STRESSG) \
                $(TESTBITS) $(CTORTURE) $(QPRANDOM) $(THREADS) $(STRESSSP) \
                $(STRESSVEC) $(STRESSFIT) $(STRESSHISTOFIT) $(STRESSHEPIX) \
                $(STRESSENTRYLIST) $(STRESSROOFIT) $(STRESSROOSTATS) \
                $(STRESSHISTFACTORY) $(STRESSPROOF) $(STRESSMATH) \
                $(STRESSMATHMORE) $(STRESSTMVA) $(STRESSINTERP) $(STRESSITER) \
                $(STRESSHIST) $(STRESSGUI) $(SQLITETEST)

OBJS         += $(GUITESTO) $(GUIVIEWERO) $(TETRISO)
PROGRAMS     += $(GUITEST) $(GUIVIEWER) $(TETRISSO)

ifeq ($(ARCH),aix5)
MAKESHARED    = /usr/vacpp/bin/makeC++SharedLib
endif

#------------------------------------------------------------------------------

.SUFFIXES: .$(SrcSuf) .$(ObjSuf) .$(DllSuf)
.PHONY:    Aclock Hello Tetris

all:            $(PROGRAMS)

$(EVENTSO):     $(EVENTO)
ifeq ($(ARCH),aix5)
		$(MAKESHARED) $(OutPutOpt) $@ $(LIBS) -p 0 $^
else
ifeq ($(PLATFORM),macosx)
# We need to make both the .dylib and the .so
		$(LD) $(SOFLAGS)$@ $(LDFLAGS) $^ $(OutPutOpt) $@ $(EXPLLINKLIBS)
ifneq ($(subst $(MACOSX_MINOR),,1234),1234)
ifeq ($(MACOSX_MINOR),4)
		ln -sf $@ $(subst .$(DllSuf),.so,$@)
endif
endif
else
ifeq ($(PLATFORM),win32)
		bindexplib $* $^ > $*.def
		lib -nologo -MACHINE:IX86 $^ -def:$*.def \
		   $(OutPutOpt)$(EVENTLIB)
		$(LD) $(SOFLAGS) $(LDFLAGS) $^ $*.exp $(LIBS) \
		   $(OutPutOpt)$@
		$(MT_DLL)
else
		$(LD) $(SOFLAGS) $(LDFLAGS) $^ $(OutPutOpt) $@ $(EXPLLINKLIBS)
endif
endif
endif
		@echo "$@ done"

$(EVENTMTSO):     $(EVENTMTO)
ifeq ($(ARCH),aix5)
		$(MAKESHARED) $(OutPutOpt) $@ $(LIBS) -p 0 $^
else
ifeq ($(PLATFORM),macosx)
# We need to make both the .dylib and the .so
		$(LD) $(SOFLAGS)$@ $(LDFLAGS) $^ $(OutPutOpt) $@ $(EXPLLINKLIBS)
ifneq ($(subst $(MACOSX_MINOR),,1234),1234)
ifeq ($(MACOSX_MINOR),4)
		ln -sf $@ $(subst .$(DllSuf),.so,$@)
endif
endif
else
ifeq ($(PLATFORM),win32)
		bindexplib $* $^ > $*.def
		lib -nologo -MACHINE:IX86 $^ -def:$*.def \
		   $(OutPutOpt)$(EVENTMTLIB)
		$(LD) $(SOFLAGS) $(LDFLAGS) $^ $*.exp $(LIBS) \
		   $(OutPutOpt)$@
		$(MT_DLL)
else
		$(LD) $(SOFLAGS) $(LDFLAGS) $^ $(OutPutOpt) $@ $(EXPLLINKLIBS)
endif
endif
endif
		@echo "$@ done"

$(EVENT):       $(EVENTSO) $(MAINEVENTO)
		$(LD) $(LDFLAGS) $(MAINEVENTO) $(EVENTO) $(LIBS) $(OutPutOpt)$@
		$(MT_EXE)
		@echo "$@ done"

$(HWORLD):      $(HWORLDO)
		$(LD) $(LDFLAGS) $^ $(LIBS) $(OutPutOpt)$@
		$(MT_EXE)
		@echo "$@ done"

$(CTORTURE):    $(CTORTUREO)
		$(LD) $(LDFLAGS) $^ $(LIBS) $(OutPutOpt)$@
		$(MT_EXE)
		@echo "$@ done"

$(HSIMPLE):     $(HSIMPLEO)
		$(LD) $(LDFLAGS) $^ $(LIBS) $(OutPutOpt)$@
		$(MT_EXE)
		@echo "$@ done"

$(MINEXAM):     $(MINEXAMO)

=== tmva/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT tmva package
# @author Pere Mato, CERN
############################################################################
if(NOT CMAKE_PROJECT_NAME STREQUAL ROOT)
  cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
  project(TMVA)
  find_package(ROOT REQUIRED)
  include(${ROOT_USE_FILE})
endif()

ROOT_USE_PACKAGE(math/mathcore)
ROOT_USE_PACKAGE(math/minuit)
ROOT_USE_PACKAGE(math/mlp)
ROOT_USE_PACKAGE(hist/histpainter)
ROOT_USE_PACKAGE(tree/treeplayer)
ROOT_USE_PACKAGE(io/xml)

set(headers1 Configurable.h Event.h Factory.h MethodBase.h MethodCompositeBase.h
	     MethodANNBase.h MethodTMlpANN.h MethodRuleFit.h MethodCuts.h MethodFisher.h
	     MethodKNN.h MethodCFMlpANN.h MethodCFMlpANN_Utils.h MethodLikelihood.h
	     MethodHMatrix.h MethodPDERS.h MethodBDT.h MethodDT.h MethodSVM.h MethodBayesClassifier.h
	     MethodFDA.h MethodMLP.h MethodBoost.h
	     MethodPDEFoam.h MethodLD.h MethodCategory.h)
set(headers2 TSpline2.h TSpline1.h PDF.h BinaryTree.h BinarySearchTreeNode.h BinarySearchTree.h 
	     Timer.h RootFinder.h CrossEntropy.h DecisionTree.h DecisionTreeNode.h MisClassificationError.h 
	     Node.h SdivSqrtSplusB.h SeparationBase.h RegressionVariance.h Tools.h Reader.h 
	     GeneticAlgorithm.h GeneticGenes.h GeneticPopulation.h GeneticRange.h GiniIndex.h 
	     GiniIndexWithLaplace.h SimulatedAnnealing.h QuickMVAProbEstimator.h)
set(headers3 Config.h KDEKernel.h Interval.h LogInterval.h FitterBase.h MCFitter.h GeneticFitter.h 
         SimulatedAnnealingFitter.h MinuitFitter.h MinuitWrapper.h IFitterTarget.h
         PDEFoam.h PDEFoamDecisionTree.h PDEFoamDensityBase.h PDEFoamDiscriminantDensity.h
         PDEFoamEventDensity.h PDEFoamTargetDensity.h PDEFoamDecisionTreeDensity.h PDEFoamMultiTarget.h
         PDEFoamVect.h PDEFoamCell.h PDEFoamDiscriminant.h PDEFoamEvent.h PDEFoamTarget.h
         PDEFoamKernelBase.h PDEFoamKernelTrivial.h PDEFoamKernelLinN.h PDEFoamKernelGauss.h
         BDTEventWrapper.h CCTreeWrapper.h
         CCPruner.h CostComplexityPruneTool.h SVEvent.h OptimizeConfigParameters.h)
set(headers4 TNeuron.h TSynapse.h TActivationChooser.h TActivation.h TActivationSigmoid.h TActivationIdentity.h
         TActivationTanh.h TActivationRadial.h TNeuronInputChooser.h TNeuronInput.h TNeuronInputSum.h
	     TNeuronInputSqSum.h TNeuronInputAbs.h Types.h Ranking.h RuleFit.h RuleFitAPI.h IMethod.h MsgLogger.h
	     VariableTransformBase.h VariableIdentityTransform.h VariableDecorrTransform.h VariablePCATransform.h 
	     VariableGaussTransform.h VariableNormalizeTransform.h VariableRearrangeTransform.h)

#---Need to suffix each header name by TMVA/  -----------------
foreach(hs headers1 headers2 headers3 headers4)
  foreach(h ${${hs}})
    set(t${hs} ${t${hs}} TMVA/${h})
  endforeach()
endforeach()

ROOT_GENERATE_DICTIONARY(G__TMVA1 ${theaders1} LINKDEF LinkDef1.h)
ROOT_GENERATE_DICTIONARY(G__TMVA2 ${theaders2} LINKDEF LinkDef2.h)
ROOT_GENERATE_DICTIONARY(G__TMVA3 ${theaders3} LINKDEF LinkDef3.h)
ROOT_GENERATE_DICTIONARY(G__TMVA4 ${theaders4} LINKDEF LinkDef4.h)

ROOT_GENERATE_ROOTMAP(TMVA LINKDEF LinkDef1.h LinkDef2.h LinkDef3.h LinkDef4.h
                           DEPENDENCIES RIO Hist Matrix Tree Graf Gpad TreePlayer MLP Minuit MathCore XMLIO)

ROOT_LINKER_LIBRARY(TMVA *.cxx G__TMVA1.cxx G__TMVA2.cxx G__TMVA3.cxx G__TMVA4.cxx LIBRARIES Core Cint 
                    DEPENDENCIES RIO Hist Tree MLP Minuit XMLIO)

install(DIRECTORY inc/TMVA/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/TMVA
                            COMPONENT headers
                            PATTERN ".svn" EXCLUDE
                            REGEX "LinkDef" EXCLUDE )
set_property(GLOBAL APPEND PROPERTY ROOT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/inc)

#if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_INSTALL_PREFIX)
#  install(DIRECTORY test DESTINATION ${CMAKE_INSTALL_DOCDIR}/tmva PATTERN ".svn" EXCLUDE)
#endif()

=== tutorials/CMakeLists.txt ===
# CMakeLists.txt for the ROOT tutorials programs.
# Author: Pere Mato, 25/10/2010
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

project(tutorials)
find_package(ROOT REQUIRED)


if(DEFINED ROOT_SOURCE_DIR)  # Testing using the binary tree
  set(ROOT_root_CMD root.exe)
  if(NOT WIN32)  # Ignore environment on Windows for the time being
    set(ROOT_environ PATH=${CMAKE_BINARY_DIR}/bin:$ENV{PATH}
                     ${ld_library_path}=${CMAKE_BINARY_DIR}/lib:$ENV{${ld_library_path}}
                     ROOTSYS=${CMAKE_BINARY_DIR}
                     PYTHONPATH=${CMAKE_BINARY_DIR}/lib:$ENV{PYTHONPATH})
  endif()
endif()

#---Definition of the helper function--------------------------------
function(ROOT_ADD_TUTORIAL macrofile rc)
  string(REPLACE ".C" "" name ${macrofile})
  string(REPLACE "/" "-" name ${name})
  ROOT_ADD_TEST(tutorial-${name} COMMAND ${ROOT_root_CMD} -b -l -n -q ${CMAKE_CURRENT_SOURCE_DIR}/${macrofile}
                PASSRC ${rc} FAILREGEX "Error in" "error:" LABELS tutorial)
endfunction()

#---Tutorials disabled depending on the build components-------------
if(NOT ROOT_minuit2_FOUND)
  set(minuit2_veto fit/fit2dHist.C fit/fit2dHist.C
                   fit/fitCircle.C fit/minuit2FitBench2D.C
                   fit/minuit2FitBench2D.C fit/minuit2FitBench.C
                   fit/minuit2FitBench.C fit/minuit2GausFit.C
                   fit/minuit2GausFit.C fit/NumericalMinimization.C
                   fit/combinedFit.C)
endif()

if(NOT ROOT_roofit_FOUND)
  set(roofit_veto  fit/RoofitDemo.C 
                   roofit/*.C roostats/*.C histfactory/*.C)
endif()

if(NOT ROOT_unuran_FOUND)
  set(unuran_veto  math/testrandom.C unuran/unuranDemo.C unuran/unuranFoamTest.C)
endif()

if(NOT ROOT_xml_FOUND)
  set(xml_veto  xml/*.C
                histfactory/*.C)   # histfactory requires xml
endif()

if(NOT ROOT_fitsio_FOUND)
  set(fitsio_veto  fitsio/*.C)
endif()

if(NOT ROOT_mathmore_FOUND)
  set(mathmore_veto 
      math/quasirandom.C 
      math/exampleMultiRoot.C
      math/Bessel.C
      math/LegendreAssoc.C
      math/Legendre.C
      math/mathmoreIntegration.C
      math/tStudent.C
      math/normalDist.C)
endif()

if(NOT ROOT_fftw3_FOUND)
  set(fftw3_veto roofit/rf208_convolution.C
                 roofit/rf210_angularconv.C
                 roofit/rf211_paramconv.C
                 roofit/rf512_wsfactory_oper.C
                 fft/FFT.C)
endif()

if(NOT GRAPHVIZ_FOUND)
  set(gviz_veto graphs/graphstruct.C)
endif()

#---These ones requires a display to run-----------------------------
set(gui_veto fit/fitpanel_playback.C
             cocoa/*.C
             geom/*.C
             gl/*.C
             gui/*.C
             hist/exec1.C 
             hist/exec2.C
             image/*.C
             graphics/psview.C graphics/gtime.C
             graphics/graph_edit_playback.C
             roostats/ModelInspector.C
             tree/tvdemo.C
             eve/*.C)

#---These ones are disabled !!! ------------------------------------
set(extra_veto
  htmlex.C
  rootalias.C          # Helper macro
  rootlogon.C          # Helper macro
  rootlogoff.C         # Helper macro
  rootmarks.C          # Instrumentation. Not a standalone tutorial
  memstat/memstat.C    # Instrumentation. Not a standalone tutorial
  html/*.C
  net/*.C
  proof/*.C
  pythia/*.C
  sql/*.C
  tree/hsimpleProxy.C  # A driver uses this macro which cannot be executed directly
  tree/tree0.C 
  tree/tree2a.C 
  tree/tree4.C
  roostats/rs401d_FeldmanCousins.C  # Takes too much time
  roostats/rs_bernsteinCorrection.C # Takes too much output :-)
  roofit/rf104_classfactory.C
  histfactory/ModifyInterpolation.C
  tree/copytree2.C 
  tree/copytree3.C 
  tree/copytree.C
  http/*.C)
  
set(all_veto hsimple.C
             ${extra_veto}
             ${gui_veto}
             ${minuit2_veto}
             ${roofit_veto}
             ${unuran_veto}
             ${xml_veto}
             ${fitsio_veto}
             ${mathmore_veto}
             ${fftw3_veto}
             ${gviz_veto})
             
file(GLOB_RECURSE tutorials RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.C)
file(GLOB tutorials_veto RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${all_veto})

list(LENGTH tutorials total)
list(LENGTH tutorials_veto veto)
message(STATUS "${veto}/${total} tutorials have been vetoed for various reasons")

list(REMOVE_ITEM tutorials ${tutorials_veto})

#---Special return code------------------------------------------------
set(returncode_1 fit/fit2a.C fit/graph2dfit.C
                 graphics/archi.C graphics/arrow.C
                 graphics/crown.C graphics/diamond.C
                 graphics/earth.C graphics/ellipse.C
                 graphics/event.C graphics/pavetext.C
                 graphics/tmathtext.C graphics/tmathtext2.C
                 graphs/exclusiongraph.C graphs/multigraph.C
                 graphs/multipalette.C
                 graphs/graphstruct.C
                 hist/ContourList.C hist/hstack.C 
                 hist/h2proj.C 
                 hist/th2polyBoxes.C
                 tree/h1analysis.C
                 io/fildir.C 
                 math/chi2test.C )
#---Dependencies------------------------------------------------------
set(math-testUnfold5d-depends tutorial-math-testUnfold5c)
set(math-testUnfold5c-depends tutorial-math-testUnfold5b)
set(math-testUnfold5b-depends tutorial-math-testUnfold5a)
set(xml-xmlreadfile-depends tutorial-xml-xmlnewfile)
set(roofit-rf503_wspaceread-depends tutorial-roofit-rf502_wspacewrite)
set(histfactory-example-depends tutorial-histfactory-makeExample)
set(io-readCode-depends tutorial-io-importCode)
set(fit-fit1-depends tutorial-hist-fillrandom)
set(foam-foam_demopers-depends tutorial-foam-foam_demo)
#--many roostats tutorials depending on having creating the file first with histfactory 
foreach(tname  ModelInspector OneSidedFrequentistUpperLimitWithBands StandardBayesianMCMCDemo StandardBayesianNumericalDemo
               StandardFeldmanCousinsDemo  StandardFrequentistDiscovery StandardHistFactoryPlotsWithCategories StandardHypoTestDemo 
               StandardHypoTestInvDemo StandardProfileInspectorDemo StandardTestStatDistributionDemo
               OneSidedFrequentistUpperLimitWithBands TwoSidedFrequentistUpperLimitWithBands)
  set(roostats-${tname}-depends tutorial-roostats-StandardProfileLikelihoodDemo)
endforeach()

#--With ACLiC---------------------------------------------------------
set(fit-combinedFit-aclic +)
set(fit-line3Dfit-aclic +) 
set(fit-TwoHistoFit2D-aclic +)
set(math-testUnfold4-aclic +)
set(io-double32-aclic +)
set(tree-hvector-aclic +)
set(math-testrandom-aclic +)

#---Loop over all tutorials and define the corresponding test---------

ROOT_ADD_TEST(tutorial-hsimple COMMAND ${ROOT_root_CMD} -b -l -n -q ${CMAKE_CURRENT_SOURCE_DIR}/hsimple.C
                PASSRC 1 FAILREGEX "Error in" "error:" LABELS tutorial)
foreach(t ${tutorials})
  list(FIND returncode_1 ${t} index)
  if(index EQUAL -1)
    set(rc 0)
  else()
    set(rc 1)
  endif()
  string(REPLACE ".C" "" tname ${t})
  string(REPLACE "/" "-" tname ${tname})
  ROOT_ADD_TEST(tutorial-${tname} 
                COMMAND ${ROOT_root_CMD} -b -l -n -q ${CMAKE_CURRENT_SOURCE_DIR}/${t}${${tname}-aclic}
                PASSRC ${rc} FAILREGEX "Error in" "error:" "segmentation violation"
                LABELS tutorial
                DEPENDS tutorial-hsimple ${${tname}-depends}
                ENVIRONMENT ${ROOT_environ})
endforeach()


#---Python tutorials-----------------------------------------------------
if(ROOT_python_FOUND)
  find_package(PythonInterp REQUIRED)

  file(GLOB pytutorials RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} pyroot/*.py)
  set(pyveto pyroot/demo.py         # requires GUI
             pyroot/fit1_py.py      # not a tutorial
             pyroot/gui_ex.py       # requires GUI
             pyroot/mrt.py          # not really a tutorial
             pyroot/na49geomfile.py # ????
             pyroot/na49visible.py  # ????
             pyroot/parse_CSV_file_with_TTree_ReadStream.py # not a tutorial
             pyroot/qtexample.py    # requires GUI/Qt
             pyroot/numberEntry.py  # requires GUI
             )
  list(REMOVE_ITEM pytutorials ${pyveto})

  #---Python tutorials dependencies--------------------------------------
  set(pyroot-hsimple-depends tutorial-hsimple)
  set(pyroot-ntuple1-depends tutorial-pyroot-hsimple)
  set(pyroot-benchmarks-depends tutorial-pyroot-hsimple)
  set(pyroot-fit1-depends tutorial-pyroot-fillrandom)

  foreach(t ${pytutorials})
    string(REPLACE ".py" "" tname ${t})
    string(REPLACE "/" "-" tname ${tname})
    ROOT_ADD_TEST(tutorial-${tname}
                COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/${t} -b
                PASSRC ${rc} FAILREGEX "Error in" "error:" "segmentation violation"
                LABELS tutorial
                DEPENDS ${${tname}-depends}
                ENVIRONMENT ${ROOT_environ})
  endforeach()
endif()

=== bindings/pyroot/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT bindings/pyroot package
############################################################################
ROOT_USE_PACKAGE(math/mathcore)
ROOT_USE_PACKAGE(tree/tree)
include_directories(${PYTHON_INCLUDE_DIRS})

ROOT_GENERATE_DICTIONARY(G__PyROOT *.h LINKDEF LinkDef.h)
ROOT_GENERATE_ROOTMAP(PyROOT LINKDEF LinkDef.h)

if(GCC_MAJOR EQUAL 4)
  add_definitions(-fno-strict-aliasing)
endif()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL Clang)
  add_definitions(-Wno-parentheses-equality)
endif()

ROOT_LINKER_LIBRARY(PyROOT *.cxx G__PyROOT.cxx LIBRARIES RIO Net Hist Graf Graf3d Gpad Tree Matrix Thread ${Reflexlib} ${PYTHON_LIBRARIES})
if(WIN32)
  set_target_properties(PyROOT PROPERTIES SUFFIX ".pyd")
endif()
if(MACOSX_MINOR EQUAL 5)
  ROOT_EXECUTABLE(python64 python64.c LIBRARIES  ${PYTHON_LIBRARIES})
endif()

#---Install python modules--------------------------------------------------
file(GLOB pyfiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.py)
foreach(pyfile ${pyfiles})
  install(FILES ${pyfile} DESTINATION ${runtimedir})
  install(CODE "execute_process(COMMAND python -m py_compile \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/${runtimedir}/${pyfile} )")
  install(CODE "execute_process(COMMAND python -O -m py_compile \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/${runtimedir}/${pyfile} )")
    if(testing)
    file(COPY ${pyfile} DESTINATION ${CMAKE_BINARY_DIR}/${runtimedir})
  endif()
endforeach()

#---Install headers----------------------------------------------------------
ROOT_INSTALL_HEADERS()

=== cint/ROOT/CMakeLists.txt ===
ROOT_USE_PACKAGE(core/base)
ROOT_USE_PACKAGE(core/meta)
ROOT_USE_PACKAGE(core/clib)
ROOT_USE_PACKAGE(core/cont)
ROOT_USE_PACKAGE(cint/cint)

set(CINTSTLDLLNAMES
    vector 
    vectorbool 
    list 
    deque 
    map 
    map2 
    set 
    multimap 
    multimap2 
    multiset 
    stack 
    queue 
    exception 
    stdexcept 
    climits 
    complex
    stdcxxfunc
   )
set(CINTDLLDIR ${CMAKE_SOURCE_DIR}/cint/cint/lib/dll_stl/)
set(CINTSTLDLLHEADERS
    ${CINTDLLDIR}/vec.h
    ${CINTDLLDIR}/vecbool.h 
    ${CINTDLLDIR}/lst.h 
    ${CINTDLLDIR}/dqu.h 
    ${CINTDLLDIR}/mp.h 
    ${CINTDLLDIR}/mp.h 
    ${CINTDLLDIR}/st.h 
    ${CINTDLLDIR}/multmp.h 
    ${CINTDLLDIR}/multmp.h 
    ${CINTDLLDIR}/multst.h 
    ${CINTDLLDIR}/stk.h 
    ${CINTDLLDIR}/que.h 
    ${CINTDLLDIR}/cinteh.h 
    ${CINTDLLDIR}/se.h 
    ${CINTDLLDIR}/clim.h 
    ${CINTDLLDIR}/cmplx.h
    ${CMAKE_SOURCE_DIR}/cint/cint/lib/stdstrct/stdcxxfunc.h
  )
set(CINTINCDLLNAMES 
    stdfunc 
#    stdcxxfunc
   )
set(CINTINCDLLHEADERS
    ${CMAKE_SOURCE_DIR}/cint/cint/lib/stdstrct/stdfunc.h 
#    ${CMAKE_SOURCE_DIR}/cint/cint/lib/stdstrct/stdcxxfunc.h
   )
if(NOT WIN32)
  set(CINTSTLDLLNAMES ${CINTSTLDLLNAMES}  valarray)
  set(CINTSTLDLLHEADERS ${CINTSTLDLLHEADERS} ${CINTDLLDIR}/vary.h)
  set(CINTINCDLLNAMES ${CINTINCDLLNAMES} posix ipc)
  set(CINTINCDLLHEADERS ${CINTINCDLLHEADERS} 
    ${CMAKE_SOURCE_DIR}/cint/cint/lib/posix/exten.h 
    ${CMAKE_SOURCE_DIR}/cint/cint/lib/ipc/ipcif.h)
endif()

set(CINTBUILDLOADER
    vector 
    list 
    deque 
    map 
    map2 
    set 
    multimap 
    multimap2 
    multiset 
    valarray
    complex
)

set(CINTDLLCXXFLAGS "${CINT_CXX_DEFINITIONS} -DG__HAVE_CONFIG -DG__NOMAKEINFO")
set(CINTDLLCFLAGS "${CINT_C_DEFINITIONS} -DG__HAVE_CONFIG -DG__NOMAKEINFO -DG__SYSTYPES")

if(MACOSX_TMPNAM_DEPRECATED OR CMAKE_COMPILER_IS_GNUCXX)
  add_definitions(-Wno-deprecated-declarations)
endif()

set(IncludeDirs -I${CMAKE_SOURCE_DIR}/cint/cint/lib/dll_stl  -I${CMAKE_SOURCE_DIR}/cint/cint/lib -I${HEADER_OUTPUT_PATH})

foreach(_name ${CINTSTLDLLNAMES}) 
  set(OutFileName ${CMAKE_CURRENT_BINARY_DIR}/G__cpp_${_name}.cxx)
  set(LoaderName ${CMAKE_CURRENT_BINARY_DIR}/stlLoader_${_name}.cc)
  list(FIND CINTSTLDLLNAMES ${_name} _position)
  list(GET CINTSTLDLLHEADERS ${_position} InFileName)
  if(${_name} MATCHES map2)
    set(AdditionalFlags "-DG__MAP2")
  else()
    set(AdditionalFlags "")
  endif()

  add_Custom_Command(OUTPUT ${OutFileName} 
                     COMMAND cint_tmp -w1 -z${_name} -n${OutFileName} ${AdditionalFlags} -D__MAKECINT__ -DG__MAKECINT ${IncludeDirs} -c-1 -A -Z0 ${InFileName} ${AdditionalHeaderFiles}
                     WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                     DEPENDS ${CINTDEP}
                    ) 
                    
  list(FIND CINTBUILDLOADER ${_name} _position)
  if(NOT _position EQUAL -1)
    add_Custom_Command(OUTPUT ${LoaderName}
                       COMMAND cmake -E copy_if_different ${CMAKE_SOURCE_DIR}/core/metautils/src/stlLoader.cc  ${LoaderName}
                      )

    set_Source_Files_Properties(${LoaderName} PROPERTIES
                                COMPILE_FLAGS "${CINTDLLCXXFLAGS} -I${CMAKE_SOURCE_DIR}/cint/cint/inc"
                                COMPILE_DEFINITIONS WHAT="${_name}"
                               )
    set(Dictionary ${CMAKE_CURRENT_BINARY_DIR}/rootcint_${_name})

    if(${_name} MATCHES map)
      set(_name1 map)
    elseif(${_name} MATCHES set)
      set(_name1 set)
    else()
      set(_name1 ${_name})
    endif()
    set(linkdeffile "${CMAKE_SOURCE_DIR}/core/metautils/src/${_name}Linkdef.h")
    
    #ROOT_GENERATE_DICTIONARY( ${Dictionary} ${_name1} LINKDEF ${linkdeffile})
    add_custom_command(OUTPUT ${Dictionary}.cxx ${Dictionary}.h
                       COMMAND rootcint_tmp -cint -f ${Dictionary}.cxx -c 
                               -I${CMAKE_CURRENT_SOURCE_DIR}/inc 
                               -I${CMAKE_BINARY_DIR}/include
                               -I${CMAKE_SOURCE_DIR}/cint/cint/include 
                               -I${CMAKE_SOURCE_DIR}/cint/cint/stl 
                               -I${CMAKE_SOURCE_DIR}/cint/cint/lib
                               -I${CMAKE_SOURCE_DIR}/core/base/inc
                               -I${CMAKE_SOURCE_DIR}/core/meta/inc 
                               -I${CMAKE_SOURCE_DIR}/core/clib/inc 
                               ${_name1} ${linkdeffile} 
                       DEPENDS ${linkdeffile} ${ROOTCINTDEP})

    set_source_files_properties(${Dictionary}.cxx 
                                 COMPILE_FLAGS "${CINTDLLCXXFLAGS} -DG__CINTBODY -I${HEADER_OUTPUT_PATH}"
                                )                                
                                
    add_Library(${_name}Dict SHARED ${Dictionary}.cxx )
    set_Target_properties(${_name}Dict PROPERTIES PREFIX ${libprefix} SUFFIX ${libsuffix} FOLDER Dictionaries)
	install(TARGETS ${_name}Dict RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                 LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                                 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

    if(explicitlink)
      target_link_libraries(${_name}Dict Cint Core)
    endif()
    if(_name STREQUAL vector) 
      ROOT_GENERATE_ROOTMAP( ${_name}Dict LIBRARY vector.dll DEPENDENCIES vectorbool.dll LINKDEF ${linkdeffile})
    else()
      ROOT_GENERATE_ROOTMAP( ${_name}Dict LIBRARY ${_name}.dll LINKDEF ${linkdeffile})
    endif()
  else()
    set(LoaderName)
  endif()

  add_Library(${_name} SHARED ${LoaderName} ${OutFileName} )
  set_target_properties(${_name} PROPERTIES PREFIX "" SUFFIX ".dll" FOLDER Dictionaries)
  if(explicitlink)
    target_link_libraries(${_name} Cint)
  endif()
  install(TARGETS ${_name} DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint/stl)
endforeach()


foreach(_name ${CINTINCDLLNAMES}) 
  set(OutFileName ${CMAKE_CURRENT_BINARY_DIR}/G__c_${_name}.c)
 
  list(FIND CINTINCDLLNAMES ${_name} _position)
  list(GET CINTINCDLLHEADERS ${_position} InFileName)

  if(_name MATCHES stdfunc)
    add_custom_command(OUTPUT ${OutFileName} 
                       COMMAND cint_tmp -K -w1 -z${_name} -n${OutFileName} -D__MAKECINT__ -DG__MAKECINT ${IncludeDirs} -c-2 -Z0 ${InFileName} ${AdditionalHeaderFiles}
                       WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                       DEPENDS ${CINTDEP}
                      ) 

    set_source_files_properties(${OutFileName} 
                                COMPILE_FLAGS "${CINTDLLCFLAGS} -I${CMAKE_SOURCE_DIR}/cint/cint/inc"
                               )
    add_Library(${_name} SHARED ${OutFileName})
    set_target_properties(${_name} PROPERTIES PREFIX "" SUFFIX ".dll" FOLDER Dictionaries)
    if(explicitlink)
      target_link_libraries(${_name} Cint ${CMAKE_M_LIBS})
    endif()
    install(TARGETS ${_name} DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint/include)

  elseif(_name MATCHES ipc)
    add_custom_command(OUTPUT ${OutFileName} 
                       COMMAND cint_tmp -K -w1 -z${_name} -n${OutFileName} -D__MAKECINT__ -DG__MAKECINT ${IncludeDirs} -c-2 -Z0 ${InFileName} ${AdditionalHeaderFiles}
                       WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                       DEPENDS ${CMAKE_BINARY_DIR}/cint/cint/include/sys/types.h ${CINTDEP}
                      ) 

    set_source_files_properties(${OutFileName} 
                                COMPILE_FLAGS "${CINTDLLCFLAGS} -I${CMAKE_SOURCE_DIR}/cint/cint/inc"
                               )

    add_Library(${_name} SHARED ${OutFileName})
    set_target_properties(${_name} PROPERTIES PREFIX "" SUFFIX ".dll" FOLDER Dictionaries)
    if(explicitlink)
      target_link_libraries(${_name} Cint)
    endif()
    install(TARGETS ${_name} DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint/include)

  elseif(_name MATCHES posix)
    
    add_executable(mktypes ${CMAKE_SOURCE_DIR}/cint/cint/lib/posix/mktypes.c)
    add_custom_command(OUTPUT ${HEADER_OUTPUT_PATH}/systypes.h 
                       COMMAND mktypes
                       DEPENDS mktypes
                      ) 
    add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/cint/cint/include/sys/types.h 
                       COMMAND cmake -E copy_if_different 
                               ${HEADER_OUTPUT_PATH}/systypes.h
                               ${CMAKE_BINARY_DIR}/cint/cint/include/sys/types.h
                       COMMAND cmake -E copy_if_different 
                               ${HEADER_OUTPUT_PATH}/systypes.h
                               ${CMAKE_BINARY_DIR}/cint/cint/include/systypes.h
                       DEPENDS ${HEADER_OUTPUT_PATH}/systypes.h
                      ) 

    if(MACOSX_MINOR GREATER 4)
      set(_ExtraFlag "-D__DARWIN_UNIX03")
    endif()

    add_custom_command(OUTPUT ${OutFileName} 
                       COMMAND cint_tmp -K -w1 -z${_name} -n${OutFileName} -D__MAKECINT__ -DG__MAKECINT ${_ExtraFlag} -c-2 -Z0 ${InFileName} ${AdditionalHeaderFiles} ${CMAKE_BINARY_DIR}/cint/cint/include/sys/types.h ${CMAKE_SOURCE_DIR}/cint/cint/lib/posix/posix.h
                       WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
                       DEPENDS ${CMAKE_BINARY_DIR}/cint/cint/include/sys/types.h ${CINTDEP}
                      ) 
    set_source_files_properties(${OutFileName} 
                                COMPILE_FLAGS "${CINT_C_DEFINITIONS}  -DG__HAVE_CONFIG -DG__NOMAKEINFO -I${CMAKE_SOURCE_DIR}/cint/cint/inc -I${CMAKE_SOURCE_DIR}/cint/cint/src -I${CMAKE_SOURCE_DIR}/cint/cint/src/dict -DG__SYSTYPES_H" 
                               )
    set_source_files_properties(${CMAKE_SOURCE_DIR}/cint/cint/lib/posix/exten.c
                                COMPILE_FLAGS " -DG__HAVE_CONFIG -DG__NOMAKEINFO -DG__CINTBODY"
                               )

    add_library(${_name} SHARED ${OutFileName} ${CMAKE_SOURCE_DIR}/cint/cint/lib/posix/exten.c)
    set_target_properties(${_name} PROPERTIES PREFIX "" SUFFIX ".dll" FOLDER Dictionaries)
    if(explicitlink)
      target_link_libraries(${_name} Cint)
    endif()
    install(TARGETS ${_name} DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint/include)
  endif()
endforeach()

=== cint/cint/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT cint/cint package
############################################################################

#---Defining the source files to be compiled---------------------------------------------------------
file(GLOB CINT_C_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/*.c)
set(CINT_C_SRCS ${CINT_C_SRCS} 
  ${CMAKE_CURRENT_SOURCE_DIR}/main/G__setup.c
  ${CMAKE_CURRENT_SOURCE_DIR}/src/config/strlcpy.c 
  ${CMAKE_CURRENT_SOURCE_DIR}/src/config/strlcpy.c 
  ${CMAKE_CURRENT_SOURCE_DIR}/src/config/strlcat.c 
  ${CMAKE_CURRENT_SOURCE_DIR}/src/config/snprintf.c )

file(GLOB CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cxx)
list(APPEND CINT_CXX_SRCS  
            ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/Apiif.cxx
            ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/stdstrct.cxx)
			
list(REMOVE_ITEM CINT_CXX_SRCS
            ${CMAKE_CURRENT_SOURCE_DIR}/src/config/sunos.cxx 
            ${CMAKE_CURRENT_SOURCE_DIR}/src/config/macos.cxx 
            ${CMAKE_CURRENT_SOURCE_DIR}/src/config/winnt.cxx 
            ${CMAKE_CURRENT_SOURCE_DIR}/src/config/newsos.cxx )

if(ROOT_PLATFORM STREQUAL linux)  
  list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/libstrm.cxx )
elseif(ROOT_PLATFORM STREQUAL macosx)
  list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/libstrm.cxx )
elseif(ROOT_PLATFORM STREQUAL win32)
  list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/config/winnt.cxx)
  if(VC_MAJOR EQUAL 17)
    list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/vc11strm.cxx)
  elseif(VC_MAJOR EQUAL 16)
    list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/vc10strm.cxx)
  elseif(VC_MAJOR EQUAL 13 AND VC_MINOR EQUAL 10)
    list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/vc7strm.cxx)
  elseif(VC_MAJOR LESS 14)	
    list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/vc7strm.cxx)
  else()
    list(APPEND CINT_CXX_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/dict/iccstrm.cxx)
  endif()
endif()  

#---Add/remove sourcefiles depending on the platform---------------------------------------------------
include(${CMAKE_CURRENT_SOURCE_DIR}/PlatformDependentSettings.cmake)
set(CINT_SRCS ${CINT_C_SRCS} ${CINT_CXX_SRCS})
list(REMOVE_ITEM CINT_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/src/loadfile.cxx)

#---Change compile settings depending on the platform--------------------------------------------------
set(CINT_CXX_DEFINITIONS "${CINT_CXX_DEFINITIONS} -DG__HAVE_CONFIG -DG__NOMAKEINFO -DG__CINTBODY")
set(CINT_C_DEFINITIONS "${CINT_C_DEFINITIONS} -DG__HAVE_CONFIG -DG__NOMAKEINFO -DG__CINTBODY")
add_definitions(${CINT_CXX_DEFINITIONS})                
                
#---Version of loadfile.cxx with different compiler settings needed for the cint_tmp executable--------
add_custom_command(OUTPUT loadfile_tmp.cxx
                   COMMAND cmake -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/src/loadfile.cxx loadfile_tmp.cxx )
set_source_files_properties(loadfile_tmp.cxx  COMPILE_FLAGS "-UR__HAVE_CONFIG -DROOTBUILD ${CINT_TMP_INC}")

#---Generate and/or copy the iosenum headerfile to the include directory-------------------------------
if(${CLANG_MAJOR} GREATER 2)
  set(IOSENUM_H ${PROJECT_SOURCE_DIR}/cint/iosenum/iosenum.${ROOT_ARCHITECTURE}3)
elseif(${GCC_MAJOR} EQUAL 4)
  set(IOSENUM_H ${PROJECT_SOURCE_DIR}/cint/iosenum/iosenum.${ROOT_ARCHITECTURE}3)
elseif(${GCC_MAJOR} EQUAL 3)
  set(IOSENUM_H ${PROJECT_SOURCE_DIR}/cint/iosenum/iosenum.${ROOT_ARCHITECTURE}3)
else()
  set(IOSENUM_H ${PROJECT_SOURCE_DIR}/cint/iosenum/iosenum.${ROOT_ARCHITECTURE})
endif()

if(EXISTS ${IOSENUM_H})
  #---copy headerfile from source directory to build directory
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/iosenum.h
    COMMAND cmake -E copy ${IOSENUM_H} ${CMAKE_CURRENT_BINARY_DIR}/iosenum.h)
else()
  #---create header file using cint
  add_custom_command(
     OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/iosenum.h
     COMMAND echo 
     COMMAND cint_tmp -I${CMAKE_CURRENT_SOURCE_DIR}/include 
       -I${CMAKE_CURRENT_SOURCE_DIR}/stl -I${CMAKE_CURRENT_SOURCE_DIR}/lib 
       -I${HEADER_OUTPUT_PATH} ${PROJECT_SOURCE_DIR}/cint/iosenum/iosenum.cxx
     DEPENDS  ${CINTDEP}
  )
endif()

add_custom_target(IOSENUM_H
   COMMAND cmake -E copy ${CMAKE_CURRENT_BINARY_DIR}/iosenum.h  ${HEADER_OUTPUT_PATH}/iosenum.h
   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/iosenum.h 
)
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${HEADER_OUTPUT_PATH}/iosenum.h)
install(FILES ${HEADER_OUTPUT_PATH}/iosenum.h DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint/include)

set_target_properties(IOSENUM_H PROPERTIES FOLDER Builtins)
#---special compile settings------------------------------------------------------------------------------
foreach(_value ${CINT_SRCS})
  get_filename_component(_name ${_value} NAME_WE) 
  string(REGEX MATCH "^.*strm" _bla ${_name})
  set(comp_flags_tmp)
  if(_bla)
    set(comp_flags_tmp "-I${CMAKE_CURRENT_SOURCE_DIR}/lib/${_bla}")
    set_source_files_properties(${_value} COMPILE_FLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}/lib/${_bla}")
  endif()
  if(${_name} MATCHES libstrm)
    set_source_files_properties(${_value} COMPILE_FLAGS "${comp_flags_tmp} -I${CMAKE_CURRENT_SOURCE_DIR}/lib/stream")    
  elseif(${_name} MATCHES sun5strm)
    set_source_files_properties(${_value} COMPILE_FLAGS "${comp_flags_tmp} -I${CMAKE_CURRENT_SOURCE_DIR}/lib/sunstrm")    
  elseif(${_name} MATCHES vcstrm)
    set_source_files_properties(${_value} COMPILE_FLAGS "${comp_flags_tmp} -I${CMAKE_CURRENT_SOURCE_DIR}/lib/vcstream")    
  elseif(${_name} MATCHES gcc4strm)
    set_source_files_properties(${_value} COMPILE_FLAGS "${comp_flags_tmp} -Wno-strict-aliasing")
  elseif(${_name} MATCHES stdstrct)
    set_source_files_properties(${_value} COMPILE_FLAGS "-I${CMAKE_CURRENT_SOURCE_DIR}/lib/stdstrct")
  endif()
endforeach()


include_directories(src)
if(MACOSX_TMPNAM_DEPRECATED)
  add_definitions(-Wno-deprecated-declarations)
  add_definitions(-Wno-constant-logical-operand)
endif()


#---Define libraries and executables to be build------------------------------------------------------------

add_definitions(-DG__HAVE_CONFIG -DG__NOMAKEINFO -DG__CINTBODY)
# This static library is needed due to some cmake internal feature/bug
# If a source file is added to several programs the file is compiled
# more than once. In case of cint, cint_tmp, rootcint and rootcint_tmp
# this would need 4 compilations of many files.
# Creating a static library with all the files which are equal in all
# executables/libraries overcomes the problem.
# TODO: Check if this works on all platforms 
add_library(Cint_static STATIC ${CINT_SRCS})
add_dependencies(Cint_static IOSENUM_H)
if(WIN32)
  set_target_properties(Cint_static PROPERTIES STATIC_LIBRARY_FLAGS -ignore:4221)
endif()

#---Create the shared Cint library--------------------------------------------------------------------------
ROOT_LINKER_LIBRARY(Cint loadfile.cxx LIBRARIES Cint_static ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_DL_LIBS})

#---Create the cint cint executable-------------------------------------------------------------------------
ROOT_EXECUTABLE(cint.exe ${CMAKE_CURRENT_SOURCE_DIR}/main/cppmain.cxx LIBRARIES Cint NOINSTALL)

#---Create the temporary cint_tmp executable----------------------------------------------------------------
ROOT_EXECUTABLE(cint_tmp ${CMAKE_CURRENT_SOURCE_DIR}/main/cppmain.cxx 
                         ${CMAKE_CURRENT_BINARY_DIR}/loadfile_tmp.cxx LIBRARIES Cint_static ${CMAKE_THREAD_LIBS_INIT} ${CMAKE_DL_LIBS} NOINSTALL)

#---Trick to avoid building all dictionaties when CINT is changed-------------------------------------------
add_custom_target(CINTTARGET DEPENDS cint_tmp)

#---Create the makecint executable--------------------------------------------------------------------------
ROOT_EXECUTABLE(makecint ${CMAKE_SOURCE_DIR}/cint/tool/makecint.cxx LIBRARIES ${CMAKE_THREAD_LIBS_INIT} NOINSTALL)

#---Installation--------------------------------------------------------------------------------------------
ROOT_INSTALL_HEADERS()
if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_INSTALL_PREFIX)
  install(DIRECTORY lib     DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint PATTERN ".dll" EXCLUDE PATTERN ".svn" EXCLUDE)
  install(DIRECTORY include DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint PATTERN ".dll" EXCLUDE PATTERN ".svn" EXCLUDE)
  install(DIRECTORY stl     DESTINATION ${CMAKE_INSTALL_CINTINCDIR}/cint PATTERN ".dll" EXCLUDE PATTERN ".svn" EXCLUDE)
endif()

=== cint/reflex/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT cint/reflex package
############################################################################
if(CMAKE_PROJECT_NAME STREQUAL ROOT)
  ROOT_USE_PACKAGE(core/base)
  ROOT_USE_PACKAGE(core/clib)
  ROOT_USE_PACKAGE(core/meta)
  ROOT_USE_PACKAGE(core/cont)  
  ROOT_USE_PACKAGE(cint/cint)
  
  ROOT_GLOB_HEADERS(headers RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/inc 
                    ${CMAKE_CURRENT_SOURCE_DIR}/inc/Reflex/*.h 
                    ${CMAKE_CURRENT_SOURCE_DIR}/inc/Reflex/Builder/*.h )
  list(REMOVE_ITEM headers Reflex/Builder/ReflexBuilder.h Reflex/Reflex.h 
                           Reflex/SharedLibrary.h Reflex/DictionaryGenerator.h)
  #---Rootcint dictionary ---------------------------------------------------
  ROOT_GENERATE_DICTIONARY(G__Reflex ${headers} LINKDEF LinkDef.h OPTIONS -p)
  ROOT_GENERATE_ROOTMAP(ReflexDict LINKDEF LinkDef.h DEPENDENCIES Reflex )
  ROOT_MODULE_LIBRARY(ReflexDict G__Reflex.cxx LIBRARIES Reflex Cint Core)
  #---Reflex library---------------------------------------------------------
  ROOT_LINKER_LIBRARY(Reflex *.cxx LIBRARIES ${CMAKE_DL_LIBS})  
  #---genreflex files--------------------------------------------------------
  install(CODE "file(WRITE \$ENV{DESTDIR}${CMAKE_INSTALL_FULL_LIBDIR}/python/genreflex/gccxmlpath.py \"gccxmlpath = '${GCCXML_EXECUTABLE}'\n\")")
  install(DIRECTORY python/genreflex DESTINATION ${CMAKE_INSTALL_LIBDIR}/python FILES_MATCHING PATTERN "*.py" PATTERN ".svn" EXCLUDE)
  install(CODE "execute_process(COMMAND python -m compileall  \$ENV{DESTDIR}${CMAKE_INSTALL_FULL_LIBDIR}/python/genreflex)")
  #---genmap executable------------------------------------------------------
  ROOT_EXECUTABLE(genmap genmap/genmap.cxx LIBRARIES Reflex ${CMAKE_DL_LIBS})
  #---install headers--------------------------------------------------------
  #ROOT_INSTALL_HEADERS()
  install(DIRECTORY inc/Reflex/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Reflex
                            PATTERN ".svn" EXCLUDE
                            PATTERN "Makefile.am" EXCLUDE
                            REGEX "LinkDef" EXCLUDE )
else()
  PROJECT(Reflex)
  CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)

  #####################   modules   ####################

  SET(REFLEX_MODULE_DIR "${CMAKE_SOURCE_DIR}/cmake/modules")
  SET(REFLEX_TEMPLATE_DIR "${CMAKE_SOURCE_DIR}/cmake/templates")
  SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${REFLEX_MODULE_DIR}")

  INCLUDE (MacroLibrary)
  INCLUDE (ReflexMacros)

  #####################   version   ####################

  SET(REFLEX_VERSION_MAJOR 5)
  SET(REFLEX_VERSION_MINOR 08)
  SET(REFLEX_VERSION_RELEASE 00)
  SET(REFLEX_VERSION_BUILD 2)

  SET(REFLEX_VERSION "${REFLEX_VERSION_MAJOR}.${REFLEX_VERSION_MINOR}")
  SET(REFLEX_VERSION_FULL "${REFLEX_VERSION}.${REFLEX_VERSION_RELEASE}.${REFLEX_VERSION_BUILD}")

  #####################   options   ####################

  OPTION(BUILD_SHARED_LIBS "inhibits building of the static version of the Reflex lib" ON)
  OPTION(FORBID_IN_SOURCE_BUILDS "forbids in-source builds of Reflex" OFF)
  OPTION(REFLEX_ENABLE_TESTS "enables all testing-related activities" OFF)
  OPTION(REFLEX_BUILD_TESTS "builds the unit test suite" ON)

  #####################   checks    ####################

  IF (FORBID_IN_SOURCE_BUILDS)
    MACRO_ENSURE_OUT_OF_SOURCE_BUILD("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")
  ENDIF (FORBID_IN_SOURCE_BUILDS)

  #####################   config    ####################

  INCLUDE (SelectConfig)

  IF (REFLEX_CXX_FLAGS)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${REFLEX_CXX_FLAGS}")
  ENDIF (REFLEX_CXX_FLAGS)

  FOREACH (m SHARED MODULE EXE)
    SET(CMAKE_${m}_LINKER_FLAGS "${CMAKE_${m}_LINKER_FLAGS} ${REFLEX_LINKER_FLAGS} ${REFLEX_${m}_LINKER_FLAGS}")
  ENDFOREACH (m SHARED MODULE EXE)

  # add definitions required for shared libraries
  IF (NOT BUILD_SHARED_LIBS)
    ADD_DEFINITIONS(-DREFLEX_DLL_VETO)
  ENDIF (NOT BUILD_SHARED_LIBS)

  SET(DL_LIBRARY ${CMAKE_DL_LIBS})

  #####################   install   ####################

  IF (WIN32)

    SET(BIN_INSTALL_DIR      "bin"     ) # The install dir for executables (default ${EXEC_INSTALL_PREFIX}/bin)
    SET(LIB_INSTALL_DIR      "lib"     ) # The subdirectory relative to the install prefix where libraries will be installed (default is ${EXEC_INSTALL_PREFIX}/lib${LIB_SUFFIX})
    SET(INCLUDE_INSTALL_DIR  "include" ) # The subdirectory to the header prefix

  ELSE (WIN32)

    SET(BIN_INSTALL_DIR      "bin"     ) # The install dir for executables (default ${EXEC_INSTALL_PREFIX}/bin)
    SET(LIB_INSTALL_DIR      "lib"     ) # The subdirectory relative to the install prefix where libraries will be installed (default is ${EXEC_INSTALL_PREFIX}/lib${LIB_SUFFIX})
    SET(INCLUDE_INSTALL_DIR  "include" ) # The subdirectory to the header prefix

  ENDIF (WIN32)

  # The INSTALL_TARGETS_DEFAULT_ARGS variable should be used when libraries are installed.
  # The arguments are also ok for regular executables, i.e. executables which don't go
  # into sbin/ or libexec/, but for installing executables the basic syntax
  # INSTALL(TARGETS genreflex DESTINATION "${BIN_INSTALL_DIR}")
  # is enough, so using this variable there doesn't help a lot.
  # The variable must not be used for installing plugins.
  # Usage is like this:
  #    install(TARGETS Reflex ${INSTALL_TARGETS_DEFAULT_ARGS} )
  #
  # This will install libraries correctly under UNIX, OSX and Windows (i.e. dll's go
    # into bin/.
    SET(INSTALL_TARGETS_DEFAULT_ARGS  RUNTIME DESTINATION "${BIN_INSTALL_DIR}"
      LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
    ARCHIVE DESTINATION "${LIB_INSTALL_DIR}")

    #####################   package   ####################

    SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "C++ Reflection Package")
    SET(CPACK_PACKAGE_VENDOR "European Organization for Nuclear Research (CERN)")
    SET(CPACK_PACKAGE_DESCRIPTION_FILE ${CMAKE_CURRENT_SOURCE_DIR}/doc/README)
    SET(CPACK_PACKAGE_CONTACT axel.naumann@cern.ch)

    SET(CPACK_PACKAGE_VERSION_MAJOR ${REFLEX_VERSION_MAJOR})
    SET(CPACK_PACKAGE_VERSION_MINOR ${REFLEX_VERSION_MINOR})
    SET(CPACK_PACKAGE_VERSION_PATCH ${REFLEX_VERSION_RELEASE})

    SET(CPACK_STRIP_FILES TRUE)
    SET(CPACK_SOURCE_IGNORE_FILES "/CVS/" "/\\\\.svn/" "\\\\.swp$" "\\\\.#" "/#" ".*~" "cscope.*")
    SET(CPACK_SOURCE_STRIP_FILES TRUE)

    # debian
    SET(DEBIAN_PACKAGE_MAINTAINER ${CPACK_PACKAGE_CONTACT})
    SET(DEBIAN_PACKAGE_DEPENDS "gccxml (>= 0.7), python (>= 2.5)")
    SET(DEBIAN_PACKAGE_BUILDS_DEPENDS "gccxml (>= 0.7.0), python (>= 2.5), libcppunit (>= 1.12.0), libcppunit-dev (>= 1.12.0)")

    INCLUDE (CPack)

    #####################   sub dirs  ####################

    ADD_SUBDIRECTORY(doc)
    ADD_SUBDIRECTORY(inc)
    ADD_SUBDIRECTORY(python)
    ADD_SUBDIRECTORY(src)

    # enable tests only if specified
      IF (REFLEX_ENABLE_TESTS)
        ENABLE_TESTING()
        ADD_SUBDIRECTORY(test)
      ENDIF (REFLEX_ENABLE_TESTS)
endif()

=== debian/changelog ===
root-system (5.34.19+dfsg-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Make ttf-root-installer depend on ca-certificates.
    Certificates need to be available for postint configure to work.
    (Closes: #774163)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 16 Jan 2015 00:43:11 +0100

root-system (5.34.19+dfsg-1.1) unstable; urgency=medium

  [ Lifeng Sun ]
  * Fix python path.

  [ Ondřej Surý ]
  * Non-maintainer upload to fix RC bug
  * Disable debian/patches/06-globus-header.patch as pkg-config --cflags
    globus-core is broken (Closes: #764845)

 -- Ondřej Surý <ondrej@debian.org>  Fri, 24 Oct 2014 13:00:00 +0200

root-system (5.34.19+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove non-free font file. (Closes: #733285)
  * Fix Ruby header directory. (Closes: #739775)
  * Switch python-support to dh-python.

 -- Lifeng Sun <lifongsun@gmail.com>  Sat, 19 Jul 2014 12:46:06 +0800

=== debian/control ===
Source: root-system
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Lifeng Sun <lifongsun@gmail.com>
Homepage: http://root.cern.ch
Build-Depends: debhelper (>= 5.0.37.2), lsb-release, autotools-dev, po-debconf, libssl-dev, comerr-dev, libxpm-dev, libltdl-dev, x11proto-xext-dev, libxext-dev, libfreetype6-dev, libpcre3-dev, zlib1g-dev | libz-dev, liblzma-dev, python-dev (>= 2.1), graphviz, ttf-freefont, libncurses5-dev, libgraphviz-dev, libavahi-core-dev, libsqlite3-dev, libxft-dev, dh-python, ruby, ruby-dev, libglu1-mesa-dev| xlibmesa-glu-dev |  libglu-dev, libglew-dev, libftgl-dev, libgl2ps-dev, libxml2-dev, libgsl0-dev, libavahi-compat-libdnssd-dev, libldap2-dev | libldap-dev, libjpeg-dev, libpng12-dev, libtiff-dev, libafterimage-dev, libgif-dev, libxinerama-dev, libfftw3-dev | fftw3-dev, libpythia8-dev, libglobus-gss-assist-dev, libglobus-gsi-credential-dev, libglobus-common-dev, libglobus-gsi-sysconfig-dev, libglobus-gssapi-gsi-dev, libglobus-gsi-callback-dev, libglobus-gsi-cert-utils-dev, libglobus-openssl-module-dev, libglobus-gsi-proxy-core-dev, libglobus-callout-dev, globus-proxy-utils,krb5-user|heimdal-clients, libmysqlclient-dev, libiodbc2-dev | unixodbc-dev,  libpq-dev, gfortran|fortran-compiler, libqt4-dev (>= 4.3.0) | libqt3-mt-dev (>= 3.3.0), qt4-dev-tools (>= 4.3.0) | qt3-dev-tools (>= 3.3.0), libqt4-opengl-dev, libkrb5-dev|heimdal-dev
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/debian-science/packages/root-system.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/root-system.git

Package: root-system
Architecture: all
Depends: root-system-bin, libroot-core-dev, ${misc:Depends}
Recommends: libroot-graf3d-gl-dev (>= ${binary:Version}), libroot-io-xmlparser-dev (>= ${binary:Version}), libroot-math-mathmore-dev (>= ${binary:Version}), libroot-math-unuran-dev (>= ${binary:Version}), libroot-misc-memstat-dev (>= ${binary:Version}), libroot-misc-table-dev (>= ${binary:Version}), libroot-net-bonjour-dev (>= ${binary:Version}), libroot-net-ldap-dev (>= ${binary:Version}), root-plugin-graf2d-asimage (>= ${binary:Version}), root-plugin-gui-qt (>= ${binary:Version}), root-plugin-graf2d-qt (>= ${binary:Version}), root-plugin-math-fftw3 (>= ${binary:Version}), root-plugin-math-minuit2 (>= ${binary:Version}), root-plugin-net-krb5 (>= ${binary:Version}), root-plugin-sql-odbc (>= ${binary:Version}), libroot-geom-dev (>= ${binary:Version}), libroot-graf2d-gpad-dev (>= ${binary:Version}), libroot-graf2d-graf-dev (>= ${binary:Version}), libroot-graf2d-postscript-dev (>= ${binary:Version}), libroot-graf3d-eve-dev (>= ${binary:Version}), libroot-graf3d-g3d-dev (>= ${binary:Version}), libroot-gui-dev (>= ${binary:Version}), libroot-gui-ged-dev (>= ${binary:Version}), libroot-hist-dev (>= ${binary:Version}), libroot-hist-spectrum-dev (>= ${binary:Version}), libroot-html-dev (>= ${binary:Version}), libroot-io-dev (>= ${binary:Version}), libroot-math-foam-dev (>= ${binary:Version}), libroot-math-genvector-dev (>= ${binary:Version}), libroot-math-mathcore-dev (>= ${binary:Version}), libroot-math-matrix-dev (>= ${binary:Version}), libroot-math-minuit-dev (>= ${binary:Version}), libroot-math-mlp-dev (>= ${binary:Version}), libroot-math-physics-dev (>= ${binary:Version}), libroot-math-quadp-dev (>= ${binary:Version}), libroot-math-smatrix-dev (>= ${binary:Version}), libroot-math-splot-dev (>= ${binary:Version}), libroot-misc-minicern-dev (>= ${binary:Version}), libroot-montecarlo-eg-dev (>= ${binary:Version}), libroot-montecarlo-vmc-dev (>= ${binary:Version}), libroot-net-dev (>= ${binary:Version}), libroot-net-auth-dev (>= ${binary:Version}), libroot-proof-dev (>= ${binary:Version}), libroot-proof-proofplayer-dev (>= ${binary:Version}), libroot-tmva-dev (>= ${binary:Version}), libroot-tree-dev (>= ${binary:Version}), libroot-tree-treeplayer-dev (>= ${binary:Version}), root-plugin-geom-geombuilder (>= ${binary:Version}), root-plugin-geom-geompainter (>= ${binary:Version}), root-plugin-graf2d-x11 (>= ${binary:Version}), root-plugin-graf3d-x3d (>= ${binary:Version}), root-plugin-gui-fitpanel (>= ${binary:Version}), root-plugin-gui-guibuilder (>= ${binary:Version}), root-plugin-gui-sessionviewer (>= ${binary:Version}), root-plugin-hist-hbook (>= ${binary:Version}), root-plugin-hist-histpainter (>= ${binary:Version}), root-plugin-hist-spectrumpainter (>= ${binary:Version}), root-plugin-io-sql (>= ${binary:Version}), root-plugin-io-xml (>= ${binary:Version}), root-plugin-math-fumili (>= ${binary:Version}), root-plugin-tree-treeviewer (>= ${binary:Version}), root-system-proofd (>= ${binary:Version}), root-system-rootd (>= ${binary:Version}), root-system-doc  (>= ${binary:Version})
Suggests: libroot-bindings-python-dev (>= ${binary:Version}), libroot-bindings-ruby-dev (>= ${binary:Version}), libroot-roofit-dev (>= ${binary:Version}), root-plugin-geom-gdml (>= ${binary:Version}), root-plugin-montecarlo-pythia8 (>= ${binary:Version}), root-plugin-net-globus (>= ${binary:Version}), root-plugin-sql-mysql (>= ${binary:Version}), root-plugin-sql-pgsql (>= ${binary:Version})
Description: metapackage to install all ROOT packages
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently.
 .
 With the data defined as a set of objects, specialized storage methods
 can give direct access to the separate attributes of the selected
 objects, without having to touch the bulk of the data. Included are
 histogramming methods in 1, 2 and 3 dimensions, curve fitting, function
 evaluation, minimization, graphics and visualization classes to allow the
 easy creation of an analysis system that can query and process the data
 interactively or in batch mode.
 .
 The command language, the scripting (or macro) language, and the   
 programming language are all C++, thanks to the built-in CINT C++    
 interpreter. This interpreter removes the time consuming compile/link
 cycle, allowing for fast prototyping of the macros, and providing a
 good environment to learn C++. If more performance is needed, the
 interactively developed macros can be compiled using a C++ compiler.
 .
 The system has been designed in such a way that it can query its
 databases in parallel on MPP machines or on clusters of workstations
 or high-end PCs. ROOT is an open system that can be dynamically
 extended by linking external libraries. This makes ROOT a premier
 platform on which to build data acquisition, simulation and data
 analysis systems.
 .
 This package is a metapackage to ensure the installation of all
 possible ROOT packages on a system. 
 
Package: libroot-bindings-python5.34
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}, dh-python
Provides: ${python:Provides}
Replaces: root-plugin-python  (<< 5.09.01-1)
Breaks: libroot-bindings-python-dev (<< 5.34.01-1~exp1)
Description: Python extension for ROOT - runtime libraries 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Python plug-in for ROOT.  This package
 provide a Python interface to ROOT, and a ROOT interface to Python.

Package: libroot-bindings-python-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-python5.34 (= ${binary:Version}), libroot-core-dev, python-dev (>= 2.1), ${python:Depends}, ${misc:Depends} 
Replaces: libroot-python-dev
Breaks: libroot-python-dev (<< 5.19.01-1)
Description: Python extension for ROOT - development files 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the development files of Python plug-in for ROOT.

Package: libroot-bindings-ruby5.34
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends} 
Replaces: root-plugin-ruby  (<< 5.09.01-1)
Description: Ruby extension for ROOT - run-time library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.  The interface
 goes both ways - that is, you can call ROOT functions from Ruby, and
 invoke the Ruby interpreter from ROOT. 

Package: libroot-bindings-ruby-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-ruby5.34 (= ${binary:Version}), libroot-core-dev, ruby1.9.1-dev | ruby-dev (>= 4.9), ${misc:Depends} 
Breaks: libroot-ruby (<< 5.19.01-1)
Replaces: libroot-ruby
Description: Ruby extension for ROOT - development headers
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.

Package: libroot-graf3d-gl5.34
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl (<< 5.19.00-1)
Provides: root-plugin-graf3d-gl
Description: GL plugin for ROOT - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT, as well as 3D 
 rendering of histograms, and similar.  Included is also a high quality 
 3D viewer for ROOT defined geometries.

Package: libroot-graf3d-gl-dev
Architecture: any
Section: libdevel
Depends: libroot-graf3d-gl5.34 (= ${binary:Version}), libgl2ps-dev, ${misc:Depends}
Breaks: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl
Description: GL plugin for ROOT - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT.  Included is also
 a high quality 3D viewer for ROOT defined geometries.

Package: libroot-io-xmlparser5.34
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: XML parser of ROOT objects - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides XML parser routines for ROOT objects.

Package: libroot-io-xmlparser-dev
Architecture: any
Section: libdevel
Depends: libroot-io-xmlparser5.34 (= ${binary:Version}), libroot-core-dev, ${misc:Depends}
Replaces: libroot-dev, root-plugin-xml
Breaks: libroot-dev (<< 5.19.01-1), root-plugin-xml (<< 5.19.01-1)
Description: XML parser of ROOT objects - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides development files of XML parser routines for ROOT
 objects.

Package: libroot-math-mathmore5.34
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GSL interface library for ROOT
 The ROOT system provides a set of OO frameworks with all the

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

PREFIX		= /usr
SYSCONFDIR	= /etc

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_CPU    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_BUILD_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
DEB_BUILD_ARCH	     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_LDFLAGS  := $(LDFLAGS)

export CFLAGS EXTRA_LDFLAGS DEB_HOST_MULTIARCH

ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
PLATFORM	= linux
else
PLATFORM	=
endif
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
BUILDOPT	= --build=debug
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM = -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
endif
ifeq (hurd-i386,$(DEB_BUILD_ARCH))
MAKEFLAGS += -j1
endif
UNUR		= --enable-unuran
#ifneq (,$(findstring alpha, $(DEB_BUILD_ARCH)))
#UNUR		= --disable-unuran
#endif
#XRD		= --enable-xrootd
#ifneq (,$(findstring sparc, $(DEB_BUILD_ARCH)))
XRD		= --disable-xrootd
#endif

DTMP		= debian/tmp
PKGDOCDIR	= $(PREFIX)/share/doc/root
CINTDIR		= $(PREFIX)/lib/$(DEB_HOST_MULTIARCH)/root$(SOVERS)
ICONTHEME	= $(PREFIX)/share/icons/hicolor/48x48
CONFOPTIONS	:=--enable-bonjour				\
		  --enable-cintex				\
		  --enable-editline				\
		  --enable-explicitlink				\
		  --enable-gdml					\
		  --enable-globus				\
		  --enable-gsl-shared				\
		  --disable-gviz				\
		  --enable-fftw3				\
		  --enable-krb5					\
		  --enable-ldap					\
		  --enable-qt					\
		  --enable-qtgsi				\
		  --enable-mathcore				\
		  --enable-mathmore				\
		  --enable-memstat				\
		  --enable-minuit2				\
		  --enable-mysql				\
		  --enable-pgsql				\
		  --enable-pythia8				\
		  --enable-odbc					\
		  --enable-reflex				\
		  --enable-roofit				\
		  --enable-ruby					\
		  --enable-shadowpw				\
		  --enable-shared				\
		  --enable-soversion				\
		  --enable-sqlite				\
		  --enable-table				\
		  --disable-rpath				\
		  --disable-afs					\
		  --disable-srp					\
		  --disable-builtin-afterimage			\
		  --disable-builtin-ftgl			\
		  --disable-builtin-freetype			\
		  --disable-builtin-glew			\
		  --disable-builtin-pcre			\
		  --disable-builtin-zlib			\
		  --disable-builtin-lzma			\
		  --disable-alien				\
		  --disable-chirp				\
		  --disable-dcache				\
		  --disable-gfal				\
		  --disable-monalisa				\
		  --disable-oracle				\
		  --disable-pythia6				\
		  --disable-rfio				\
		  --disable-sapdb				\
		  --fail-on-missing				\
		  --with-globus=/usr				\
		  --with-globus-incdir=/usr/include/globus	\
		  --with-globus-libdir=/usr/lib			\
		  --with-odbc-incdir=/usr/include/iodbc		\
		  --with-pythia8-incdir=/usr/include/pythia8	\
		  $(UNUR)					\
		  $(XRD)					\
		  $(BUILDOPT)
#
# Things for the future 
#
#		  --enable-mathcore	libroot
#		  --enable-cintex	libroot
#		  --enable-reflex	libroot
#		  --with-globus=/opt/globus
#		  --disable-builtin-gsl				
#		  --disable-builtin				\

VERSION		:= $(shell head -n1 debian/changelog | cut -d' ' -f2 | tr -d '()')
MAJOR		:= $(shell echo $(VERSION) | cut -f1 -d'.')
MINOR		:= $(shell echo $(VERSION) | cut -f2 -d'.')
SOVERS		:= $(MAJOR).$(MINOR)
PKGLIST		:= $(shell ./configure $(PLATFORM) --pkglist $(CONFOPTIONS) | sed -n -e 's/packages: //p')
ESSENTIALS	:= libroot-core-dev			\
		   libroot-core				\
		   root-system-bin			\
		   root-system-common			\
		   ttf-root-installer		
PLUGINS		:= libroot-geom				\
		   libroot-graf2d-gpad			\
		   libroot-graf2d-graf			\
		   libroot-graf2d-postscript		\
		   libroot-graf3d-eve			\
		   libroot-graf3d-g3d			\
		   libroot-graf3d-gl			\
		   libroot-gui				\
		   libroot-gui-ged			\
		   libroot-hist				\
		   libroot-hist-spectrum		\
		   libroot-html				\
		   libroot-io				\
		   libroot-io-xmlparser			\
		   libroot-math-foam			\
		   libroot-math-genvector		\
		   libroot-math-mathcore		\
		   libroot-math-mathmore		\
		   libroot-math-matrix			\
		   libroot-math-minuit			\
		   libroot-math-mlp			\
		   libroot-math-quadp			\
		   libroot-math-physics			\
		   libroot-math-smatrix			\
		   libroot-math-splot			\
		   libroot-math-unuran			\
		   libroot-misc-minicern		\
		   libroot-misc-memstat			\
		   libroot-misc-table			\
		   libroot-montecarlo-eg		\
		   libroot-montecarlo-vmc		\
		   libroot-net				\
		   libroot-net-auth			\
		   libroot-net-bonjour			\
		   libroot-net-ldap			\
		   libroot-proof			\
		   libroot-proof-proofplayer		\
		   libroot-tmva				\
		   libroot-tree				\
		   libroot-tree-treeplayer		\
		   root-plugin-geom-geombuilder		\
		   root-plugin-geom-geompainter		\
		   root-plugin-graf2d-asimage		\
		   root-plugin-graf2d-qt		\
		   root-plugin-graf2d-x11		\
		   root-plugin-graf2d-gvi		\
		   root-plugin-graf3d-x3d		\
		   root-plugin-gui-fitpanel		\
		   root-plugin-gui-guibuilder		\
		   root-plugin-gui-qt			\
		   root-plugin-gui-sessionviewer	\
		   root-plugin-hist-hbook		\
		   root-plugin-hist-histpainter		\
		   root-plugin-hist-spectrumpainter	\
		   root-plugin-io-sql			\
		   root-plugin-io-xml			\
		   root-plugin-math-fftw3		\
		   root-plugin-math-fumili		\
		   root-plugin-math-minuit2		\
		   root-plugin-net-krb5			\
		   root-plugin-net-netx			\
		   root-plugin-sql-odbc			\
		   root-plugin-tree-treeviewer		\
		   root-system-proofd			\
		   root-system-doc			\
		   root-system-rootd
#		   root-plugin-graf2d-gviz
EXTRAS		:= libroot-bindings-python		\
		   libroot-roofit			\
		   libroot-bindings-ruby		\
		   root-plugin-geom-gdml		\
		   root-plugin-io-castor		\
		   root-plugin-io-chirp			\
		   root-plugin-io-dcache		\
		   root-plugin-montecarlo-pythia8	\
		   root-plugin-net-globus		\
		   root-plugin-net-bonjour		\
		   root-plugin-net-alien		\
		   root-plugin-net-srp			\
		   root-plugin-sql-maxdb		\
		   root-plugin-sql-mysql		\
		   root-plugin-sql-oracle		\
		   root-plugin-sql-pgsql		
PLUGINLIST	:= $(filter-out $(EXTRAS) $(ESSENTIALS), $(PKGLIST))
EXTRALIST	:= $(filter-out $(PLUGINS) $(ESSENTIALS), $(PKGLIST))
PLUGINLIST	:= $(PLUGINLIST:libroot%=libroot%-dev)
EXTRALIST	:= $(EXTRALIST:libroot%=libroot%-dev)
PLUGINHEAD	:= $(filter-out $(lastword $(PLUGINLIST)), $(PLUGINLIST))
PLUGINLIST	:= $(PLUGINHEAD:%=%,) $(lastword $(PLUGINLIST))
EXTRAHEAD	:= $(filter-out $(lastword $(EXTRALIST)), $(EXTRALIST))
EXTRALIST	:= $(EXTRAHEAD:%=%,) $(lastword $(EXTRALIST))
TEMPLATES	:= $(wildcard debian/skel/*.links.in) \
                   $(wildcard debian/skel/*.menu.in) \
                   $(wildcard debian/skel/*.prerm.in) \
                   $(wildcard debian/skel/*.preinst.in) \
                   $(wildcard debian/skel/*.postinst.in) \
                   $(wildcard debian/skel/*.init.in) \
                   $(wildcard debian/skel/*.desktop.in)
SPKGLIST	:= $(filter-out root-system-doc root-system-common ttf-root-installer, $(PKGLIST:libroot%=libroot%$(SOVERS))) $(filter libroot%, $(PKGLIST:libroot%=libroot%-dev)) libroot-static
IPKGLIST	:= root-system-doc ttf-root-installer root-system-common root-system
DPKGLIST	:= $(SPKGLIST:%=%,) root-system-doc, root-ttf
#root-plugins root-extra-plugins
SPKGOPTS	:= $(SPKGLIST:%=-p%) 
IPKGOPTS	:= $(IPKGLIST:%=-p%) 
PKGOPTS		:= $(IPKGOPTS) $(SPKGOPTS)
HAVERUBY	:= $(filter libroot-bindings-ruby, $(PKGLIST))
ifeq ($(HAVERUBY), libroot-bindings-ruby)
RUBYARCHDIR	:= $(shell ruby -rrbconfig -e 'print RbConfig::CONFIG["rubyarchhdrdir"]' | sed 's,/,,')
else
RUBYARCHDIR	:= 
endif
